// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDIDeviceInstance.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons, website),
//               Brian Austin (some source code, documentation)
// Description:  This file contains the code for the TDIDeviceInstance 
//               Component 
//
// "TDx_Input_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDIDeviceInstance.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Input_Library_Defns"
#pragma link "TDx_Input_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDIDeviceInstance*)
{
    new TDIDeviceInstance(NULL);
}
// --------------------------------------------------------------------------
namespace Tdideviceinstance
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDIDeviceInstance)};
        RegisterComponents("TDx_Input", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDIDeviceInstance::TDIDeviceInstance()
// Description: The default constructor for the TDIDeviceInstance object.
// --------------------------------------------------------------------------
__fastcall TDIDeviceInstance::TDIDeviceInstance(TComponent* Owner)
    : TComponent(Owner)
{
Clear();
}
// --------------------------------------------------------------------------
// Destructor:  TDIDeviceInstance::~TDIDeviceInstance()
// Description: The destructor for the TDIDeviceInstance object.
// --------------------------------------------------------------------------
__fastcall TDIDeviceInstance::~TDIDeviceInstance()
{
}
// --------------------------------------------------------------------------
// Property:    DevType
// Description: The DevType property identifies a device as one of four basic 
//              types, those being keyboard, mouse, joystick and unknown. 
//              
//              The three standard types have subtypes that further specify 
//              the device type. All devices can also be defined as using HID 
//              (Human Interface Device) protocol. 
//              
//              Basic types are defined in the least significant byte, 
//              subtypes in the next byte and further definitions such as HID 
//              are contained in the high order word. 
//              
//              The possible values are : 
//              
//              Basic Types 
//              
//              DIDEVTYPE_MOUSE - The device is of the mouse/trackball basic 
//              type. 
//              DIDEVTYPE_KEYBOARD - The device is of the keyboard basic 
//              type. 
//              DIDEVTYPE_JOYSTICK - The device is of the joystick basic 
//              type. 
//              DIDEVTYPE_DEVICE - The device does not fall into any of the 
//              other categories available. 
//              
//              Mouse Subtypes 
//              
//              DIDEVTYPEMOUSE_UNKNOWN - The device is a mouse, the subtype 
//              of which could not be determined. 
//              DIDEVTYPEMOUSE_TRADITIONAL - The device is a mouse of the 
//              traditional subtype. 
//              DIDEVTYPEMOUSE_FINGERSTICK - The device is a mouse of the 
//              fingerstick subtype. 
//              DIDEVTYPEMOUSE_TOUCHPAD - The device is a mouse of the 
//              touchpad subtype. 
//              DIDEVTYPEMOUSE_TRACKBALL - The device is a mouse of the 
//              trackball subtype. 
//              
//              Keyboard Subtypes 
//              
//              DIDEVTYPEKEYBOARD_UNKNOWN - The device is a keyboard, the 
//              subtype of which could not be determined. 
//              DIDEVTYPEKEYBOARD_PCXT - The device is a keyboard of the IBM 
//              PC/XT 83-key subtype. 
//              DIDEVTYPEKEYBOARD_OLIVETTI - The device is a keyboard of the 
//              Olivetti 102-key subtytpe. 
//              DIDEVTYPEKEYBOARD_PCAT - The device is a keyboard of the IBM 
//              PC/AT 84-key subtype. 
//              DIDEVTYPEKEYBOARD_PCENH - The device is a keyboard of the IBM 
//              PC Enhanced 101/102-key or Microsoft Natural subtype. 
//              DIDEVTYPEKEYBOARD_NOKIA1050 - The device is a keyboard of the 
//              Nokia 1050 subtype. 
//              DIDEVTYPEKEYBOARD_NOKIA9140 - The device is a keyboard of the 
//              Nokia 9140 subtype. 
//              DIDEVTYPEKEYBOARD_NEC98 - The device is a keyboard of the 
//              Japanese NEC PC98 subtype. 
//              DIDEVTYPEKEYBOARD_NEC98LAPTOP - The device is a keyboard of 
//              the Japanese NEC PC98 laptop subtype. 
//              DIDEVTYPEKEYBOARD_NEC98106 - The device is a keyboard of the 
//              Japanese NEC PC98 106-key subtype. 
//              DIDEVTYPEKEYBOARD_JAPAN106 - The device is a keyboard of the 
//              Japanese 106-key subtype. 
//              DIDEVTYPEKEYBOARD_JAPANAX - The device is a keyboard of the 
//              Japanese AX subtype. 
//              DIDEVTYPEKEYBOARD_J3100 - The device is a keyboard of the 
//              Japanese J3100 subtype. 
//              
//              Joystick Subtypes 
//              
//              DIDEVTYPEJOYSTICK_UNKNOWN - The device is a joystick, the 
//              subtype of which could not be determined. 
//              DIDEVTYPEJOYSTICK_TRADITIONAL - The device is a joystick of 
//              the traditional subtype. 
//              DIDEVTYPEJOYSTICK_FLIGHTSTICK - The device is a joystick of 
//              the subtype that is optimized for flight simulation. 
//              DIDEVTYPEJOYSTICK_GAMEPAD - The device is a joystick subtype 
//              whose primary purpose is to provide button input. 
//              DIDEVTYPEJOYSTICK_RUDDER - The device is a joystick subtype 
//              used for flight simulator style yaw control. 
//              DIDEVTYPEJOYSTICK_WHEEL - The device is a joystick of the 
//              steering wheel subtype. 
//              DIDEVTYPEJOYSTICK_HEADTRACKER - The device is a joystick 
//              subtype that obtains its input by tracking the movement of 
//              the user's head. 
//              
//              HID 
//              
//              DIDEVTYPE_HID - The device uses the Human Interface Device 
//              (HID) protocol. 
// --------------------------------------------------------------------------
dword __fastcall TDIDeviceInstance::FGetDevType()
{
return fDIDEVICEINSTANCE.dwDevType;
}
// --------------------------------------------------------------------------
void __fastcall TDIDeviceInstance::FSetDevType( dword pDevType )
{
fDIDEVICEINSTANCE.dwDevType = pDevType;
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDIDeviceInstance method or 
//              fget/fset. eg. DI_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDIDeviceInstance::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDIDeviceInstance::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    FFDriver
// Description: The FFDriver property defines the globally unique identifier 
//              (GUID) of the force feedback driver. 
//              
//              The driver manufacturer specifies this identifier. 
// --------------------------------------------------------------------------
GUID __fastcall TDIDeviceInstance::FGetFFDriver()
{
return fDIDEVICEINSTANCE.guidFFDriver;
}
// --------------------------------------------------------------------------
void __fastcall TDIDeviceInstance::FSetFFDriver( GUID pFFDriver )
{
fDIDEVICEINSTANCE.guidFFDriver = pFFDriver;
}
// --------------------------------------------------------------------------
// Property:    Instance
// Description: The Instance property defines a GUID for this instance of the 
//              device. 
//              
//              Instance GUID's are specific to individual computers, so 
//              instance GUID's from another computer are not transferrable. 
// --------------------------------------------------------------------------
GUID __fastcall TDIDeviceInstance::FGetInstance()
{
return fDIDEVICEINSTANCE.guidInstance;
}
// --------------------------------------------------------------------------
void __fastcall TDIDeviceInstance::FSetInstance( GUID pInstance )
{
fDIDEVICEINSTANCE.guidInstance = pInstance;
}
// --------------------------------------------------------------------------
// Property:    InstanceName
// Description: The InstanceName property defines the friendly name for this 
//              instance of the device. 
//              
//              The friendly name will be something like 'Keyboard' or 'Mouse 
//              1'. 
// --------------------------------------------------------------------------
AnsiString __fastcall TDIDeviceInstance::FGetInstanceName()
{
AnsiString tempInstanceName = fDIDEVICEINSTANCE.tszInstanceName;
return tempInstanceName;
}
// --------------------------------------------------------------------------
void __fastcall TDIDeviceInstance::FSetInstanceName( AnsiString pInstanceName )
{
int max = pInstanceName.Length();
if (max>MAX_PATH) max = MAX_PATH;

#ifdef _UNICODE
CopyMemory( &fDIDEVICEINSTANCE.tszInstanceName[0], pInstanceName.c_str(), max*2 );
#else
CopyMemory( &fDIDEVICEINSTANCE.tszInstanceName[0], pInstanceName.c_str(), max );
#endif
}
// --------------------------------------------------------------------------
// Property:    Product
// Description: The Product property defines the product GUID. 
//              
//              The device manufacturer specifies this identifier. 
// --------------------------------------------------------------------------
GUID __fastcall TDIDeviceInstance::FGetProduct()
{
return fDIDEVICEINSTANCE.guidProduct;
}
// --------------------------------------------------------------------------
void __fastcall TDIDeviceInstance::FSetProduct( GUID pProduct )
{
fDIDEVICEINSTANCE.guidProduct = pProduct;
}
// --------------------------------------------------------------------------
// Property:    ProductName
// Description: The ProductName property defines the friendly name for the 
//              device. 
//              
//              The friendly name will be something like 'Flightstick' or 
//              'Super Trackball'. 
// --------------------------------------------------------------------------
AnsiString __fastcall TDIDeviceInstance::FGetProductName()
{
AnsiString tempProductName = fDIDEVICEINSTANCE.tszProductName;
return tempProductName;
}
// --------------------------------------------------------------------------
void __fastcall TDIDeviceInstance::FSetProductName( AnsiString pProductName )
{
int max = pProductName.Length();
if (max>MAX_PATH) max = MAX_PATH;

#ifdef _UNICODE
CopyMemory( &fDIDEVICEINSTANCE.tszProductName[0], pProductName.c_str(), max*2 );
#else
CopyMemory( &fDIDEVICEINSTANCE.tszProductName[0], pProductName.c_str(), max );
#endif
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property defines the size, in bytes, of the internal 
//              structure used by this component. 
// --------------------------------------------------------------------------
dword __fastcall TDIDeviceInstance::FGetSize()
{
return fDIDEVICEINSTANCE.dwSize;
}
// --------------------------------------------------------------------------
void __fastcall TDIDeviceInstance::FSetSize( dword pSize )
{
fDIDEVICEINSTANCE.dwSize = pSize;
}
// --------------------------------------------------------------------------
// Property:    Usage
// Description: The Usage property defines the HID usage code. 
//              A usage code only applies to Human Interface Device's, 
//              otherwise it will be 0. 
//              
//              This property is used in the TDx_InputDevice::GetObjectInfo() 
//              method after being combined with the code contained in 
//              TDIDeviceInstance::UsagePage via the DIMAKEUSAGEDWORD macro. 
// --------------------------------------------------------------------------
word __fastcall TDIDeviceInstance::FGetUsage()
{
return fDIDEVICEINSTANCE.wUsage;
}
// --------------------------------------------------------------------------
void __fastcall TDIDeviceInstance::FSetUsage( word pUsage )
{
fDIDEVICEINSTANCE.wUsage = pUsage;
}
// --------------------------------------------------------------------------
// Property:    UsagePage
// Description: The UsagePage property defines the HID usage page code. 
//              A usage page code only applies to Human Interface Device's, 
//              otherwise it will be 0. 
//              
//              This property is used in the TDx_InputDevice::GetObjectInfo() 
//              method after being combined with the code contained in 
//              TDIDeviceInstance::Usage via the DIMAKEUSAGEDWORD macro. 
// --------------------------------------------------------------------------
word __fastcall TDIDeviceInstance::FGetUsagePage()
{
return fDIDEVICEINSTANCE.wUsagePage;
}
// --------------------------------------------------------------------------
void __fastcall TDIDeviceInstance::FSetUsagePage( word pUsagePage )
{
fDIDEVICEINSTANCE.wUsagePage = pUsagePage;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TDIDeviceInstance's internal DIDEVICEINSTANCE structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TDIDeviceInstance::Clear()
{
fDIDEVICEINSTANCE.dwDevType = 0;
fErrorValue = DI_OK;
ZeroMemory(&fFFDriver,sizeof(_GUID));
ZeroMemory(&fInstance,sizeof(_GUID));
ZeroMemory(&fProduct,sizeof(_GUID));
fDIDEVICEINSTANCE.dwSize = sizeof(DIDEVICEINSTANCE);
fDIDEVICEINSTANCE.wUsage = 0;
fDIDEVICEINSTANCE.wUsagePage = 0;
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
DIDEVICEINSTANCE* __fastcall TDIDeviceInstance::FGetInternal_DIDEVICEINSTANCE_Ptr()
{
return &fDIDEVICEINSTANCE;
}
// --------------------------------------------------------------------------
void __fastcall TDIDeviceInstance::FSetInternal_DIDEVICEINSTANCE( DIDEVICEINSTANCE* pDIDEVICEINSTANCE )
{
if (pDIDEVICEINSTANCE==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDIDeviceInstance::FSetInternal_DIDEVICEINSTANCE()", "TDX_ERROR", "The supplied DIDEVICEINSTANCE* was NULL" );
    return;
    }

CopyMemory( &fDIDEVICEINSTANCE, pDIDEVICEINSTANCE, sizeof(DIDEVICEINSTANCE) );
Internal_DIDEVICEINSTANCE_Update();
}
// --------------------------------------------------------------------------
void __fastcall TDIDeviceInstance::Internal_DIDEVICEINSTANCE_Update()
{
}

// --------------------------------------------------------------------------
