// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDIDeviceObjectData.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons, website),
//               Brian Austin (some source code, documentation)
// Description:  This file contains the code for the TDIDeviceObjectData 
//               Component 
//
// "TDx_Input_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDIDeviceObjectData.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Input_Library_Defns"
#pragma link "TDx_Input_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDIDeviceObjectData*)
{
    new TDIDeviceObjectData(NULL);
}
// --------------------------------------------------------------------------
namespace Tdideviceobjectdata
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDIDeviceObjectData)};
        RegisterComponents("TDx_Input", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDIDeviceObjectData::TDIDeviceObjectData()
// Description: The default constructor for the TDIDeviceObjectData object.
// --------------------------------------------------------------------------
__fastcall TDIDeviceObjectData::TDIDeviceObjectData(TComponent* Owner)
    : TComponent(Owner)
{
fDIDEVICEOBJECTDATA=NULL;
fArraySize=0;
ArraySize=1;
ClearAll();
}
// --------------------------------------------------------------------------
// Destructor:  TDIDeviceObjectData::~TDIDeviceObjectData()
// Description: The destructor for the TDIDeviceObjectData object.
// --------------------------------------------------------------------------
__fastcall TDIDeviceObjectData::~TDIDeviceObjectData()
{
// destroy internals
if (ArraySize!=0) ArraySize = 0;
}
// --------------------------------------------------------------------------
// Property:    ArraySize
// Description: The ArraySize property contains the number of internal 
//              DIDEVICEOBJECTDATA structures wrapped inside the 
//              TDIDeviceObjectData component. 
//              By default the ArraySize is initialized to 1, meaning that 
//              this TDIDeviceObjectData component wraps a single 
//              DIDEVICEOBJECTDATA structure. To wrap multiple structures, 
//              set the TDIDeviceObjectData::ArraySize to the total number of 
//              internal structures desired. 
// --------------------------------------------------------------------------
dword __fastcall TDIDeviceObjectData::FGetArraySize()
{
return fArraySize;
}
// --------------------------------------------------------------------------
void __fastcall TDIDeviceObjectData::FSetArraySize( dword pArraySize )
{
// check for size==0
if (pArraySize==0)
    {
    // de-allocate old memory
    delete[] fDIDEVICEOBJECTDATA;
    fDIDEVICEOBJECTDATA = NULL;
    fArraySize = 0;
    return;
    }

// is anything allocated?
if (fArraySize==0)
    {
    // nope. need to allocate memory for pointers to internal structures
    fDIDEVICEOBJECTDATA = new DIDEVICEOBJECTDATA[pArraySize];
    if (fDIDEVICEOBJECTDATA==NULL)
        {
        fArraySize = 0;
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError(this, "TDIDEVICEOBJECTDATA::FSetArraySize()", "TDX_ERROR", "Could not allocate memory for storing internal DIDEVICEOBJECTDATA structure pointers.");
        return;
        }
    // setup defaults
    fArraySize = pArraySize;
    ClearAll();
    }
else
    // already allocated... has the size increased?
    if (pArraySize>fArraySize)
        {
        // allocate space for the new structures
        DIDEVICEOBJECTDATA* temp_DIDEVICEOBJECTDATA = new DIDEVICEOBJECTDATA[pArraySize];
        if (temp_DIDEVICEOBJECTDATA==NULL)
            {
            fErrorValue = TDX_ERROR;
            if (FOnError) FOnError(this, "TDIDEVICEOBJECTDATA::FSetArraySize()", "TDX_ERROR", "Could not allocate extra memory for storing internal DIDEVICEOBJECTDATA structures.");
            return;
            }
        // clear new data areas
        ZeroMemory( &temp_DIDEVICEOBJECTDATA[fArraySize], sizeof(DIDEVICEOBJECTDATA)*(pArraySize-fArraySize) );
        // duplicate existing data
        CopyMemory( &temp_DIDEVICEOBJECTDATA[0], &fDIDEVICEOBJECTDATA[0], sizeof(DIDEVICEOBJECTDATA)*fArraySize);
        // de-allocate old memory
        delete[] fDIDEVICEOBJECTDATA;
        // re-assign the new memory
        fDIDEVICEOBJECTDATA = temp_DIDEVICEOBJECTDATA;
        // store new array size
        fArraySize = pArraySize;
        }
    else
        // already allocated... has the size reduced?
        if (pArraySize<fArraySize)
            {
            // allocate space for the new structures
            DIDEVICEOBJECTDATA* temp_DIDEVICEOBJECTDATA = new DIDEVICEOBJECTDATA[pArraySize];
            if (temp_DIDEVICEOBJECTDATA==NULL)
                {
                fErrorValue = TDX_ERROR;
                if (FOnError) FOnError(this, "TDIDEVICEOBJECTDATA::FSetArraySize()", "TDX_ERROR", "Could not allocate memory for storing internal DIDEVICEOBJECTDATA structures.");
                return;
                }
            // duplicate existing data
            CopyMemory( &temp_DIDEVICEOBJECTDATA[0], &fDIDEVICEOBJECTDATA[0], sizeof(DIDEVICEOBJECTDATA)*pArraySize);
            // de-allocate the old memory
            delete[] fDIDEVICEOBJECTDATA;
            // re-assign the new memory
            fDIDEVICEOBJECTDATA = temp_DIDEVICEOBJECTDATA;
            // store new array size
            fArraySize = pArraySize;
            }
// else - size is the same.
}
// --------------------------------------------------------------------------
// Property:    Data
// Description: The Data property defines the data obtained from or be sent 
//              to the device. 
//              
//              This property will define the relative motion for a relative 
//              mode axis, the axis coordinates for an absolute mode axis and 
//              the high bit of the low byte will be set for a button being 
//              depressed or cleared when the button is released. 
// --------------------------------------------------------------------------
dword __fastcall TDIDeviceObjectData::FGetData( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDIDeviceObjectData::FGetData()", "TDX_ERROR", "Internal Array size is 0.");
     return (dword) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDIDeviceObjectData::FGetData()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (dword) NULL;
    }

return fDIDEVICEOBJECTDATA[pArrayIndex].dwData;
}
// --------------------------------------------------------------------------
void __fastcall TDIDeviceObjectData::FSetData( dword pArrayIndex, dword pData )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDIDeviceObjectData::FSetData()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDIDeviceObjectData::FSetData()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fDIDEVICEOBJECTDATA[pArrayIndex].dwData = pData;
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDIDeviceObjectData method or 
//              fget/fset. eg. DI_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDIDeviceObjectData::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDIDeviceObjectData::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    Ofs
// Description: The Ofs property defines different information depending on 
//              how the TDIDeviceObjectData component is being used. 
//              
//              For TDx_InputDevice::GetDeviceData() it defines an offset 
//              into the data format of the device. When accessing one of the 
//              3 basic device types, this property should be one of the 
//              mouse, keyboard or joystick device constants. 
//              
//              For TDx_InputDevice::SendDeviceData() it defines the instance 
//              ID of the object as defined in TDIDeviceObjectInstance::Type. 
// --------------------------------------------------------------------------
dword __fastcall TDIDeviceObjectData::FGetOfs( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDIDeviceObjectData::FGetOfs()", "TDX_ERROR", "Internal Array size is 0.");
     return (dword) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDIDeviceObjectData::FGetOfs()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (dword) NULL;
    }

return fDIDEVICEOBJECTDATA[pArrayIndex].dwOfs;
}
// --------------------------------------------------------------------------
void __fastcall TDIDeviceObjectData::FSetOfs( dword pArrayIndex, dword pOfs )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDIDeviceObjectData::FSetOfs()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDIDeviceObjectData::FSetOfs()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fDIDEVICEOBJECTDATA[pArrayIndex].dwOfs = pOfs;
}
// --------------------------------------------------------------------------
// Property:    Sequence
// Description: The Sequence property defines the sequence number of the data 
//              retrieval. 
//              
//              This property can be used to chronologically sort data 
//              returned from multiple devices by 
//              TDx_InputDevice::GetDeviceData() calls. 
//              
//              When calling TDx_InputDevice::SendDeviceData(), this property 
//              must be 0. 
//              
//              Sequence numbers can wrap around, so the DISEQUENCE_COMPARE 
//              macro should be used to perform sequence comparisons safely. 
//              
//              DISEQUENCE_COMPARE(Val1, cmp, Val2) 
//              
//              where cmp can be ==, !=, <, >, <=, or >=. 
//              
//              returns nonzero if (val1 cmp Val2) is true. 
// --------------------------------------------------------------------------
dword __fastcall TDIDeviceObjectData::FGetSequence( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDIDeviceObjectData::FGetSequence()", "TDX_ERROR", "Internal Array size is 0.");
     return (dword) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDIDeviceObjectData::FGetSequence()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (dword) NULL;
    }

return fDIDEVICEOBJECTDATA[pArrayIndex].dwSequence;
}
// --------------------------------------------------------------------------
void __fastcall TDIDeviceObjectData::FSetSequence( dword pArrayIndex, dword pSequence )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDIDeviceObjectData::FSetSequence()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDIDeviceObjectData::FSetSequence()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fDIDEVICEOBJECTDATA[pArrayIndex].dwSequence = pSequence;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property contains the size in bytes of a single 
//              internal DIDEVICEOBJECTDATA structure. 
// --------------------------------------------------------------------------
dword __fastcall TDIDeviceObjectData::FGetSize()
{
return fSize;
}
// --------------------------------------------------------------------------
void __fastcall TDIDeviceObjectData::FSetSize( dword pSize )
{
fSize = pSize;
}
// --------------------------------------------------------------------------
// Property:    SizeAll
// Description: The SizeAll property contains the size in bytes of all 
//              internal DIDEVICEOBJECTDATA structures. This result is the 
//              same as multiplying TDIDeviceObjectData::ArraySize and 
//              TDIDeviceObjectData::Size. 
// --------------------------------------------------------------------------
dword __fastcall TDIDeviceObjectData::FGetSizeAll()
{
return fArraySize * fSize;
}
// --------------------------------------------------------------------------
// Property:    TimeStamp
// Description: The TimeStamp property defines the tick count, in 
//              milliseconds, when the call was made. 
//              
//              When calling TDx_InputDevice::SendDeviceData(), this property 
//              must be 0. 
//              
//              A lower resolution system tick count value can be obtained 
//              with the Win32 GetTickCount function. 
//              The tick count wraps around approximately every 50 days. 
// --------------------------------------------------------------------------
dword __fastcall TDIDeviceObjectData::FGetTimeStamp( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDIDeviceObjectData::FGetTimeStamp()", "TDX_ERROR", "Internal Array size is 0.");
     return (dword) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDIDeviceObjectData::FGetTimeStamp()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (dword) NULL;
    }

return fDIDEVICEOBJECTDATA[pArrayIndex].dwTimeStamp;
}
// --------------------------------------------------------------------------
void __fastcall TDIDeviceObjectData::FSetTimeStamp( dword pArrayIndex, dword pTimeStamp )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDIDeviceObjectData::FSetTimeStamp()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDIDeviceObjectData::FSetTimeStamp()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fDIDEVICEOBJECTDATA[pArrayIndex].dwTimeStamp = pTimeStamp;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TDIDeviceObjectData's internal DIDEVICEOBJECTDATA structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// Params:      pArrayIndex - 
//                The ArrayIndex parameter determines which internal structure 
//                needs to be cleared. Correct values range from 0 to 
//                TDIDeviceObjectData::ArraySize-1. 
// --------------------------------------------------------------------------
void __fastcall TDIDeviceObjectData::Clear( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDIDeviceObjectData::Clear()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDIDeviceObjectData::Clear()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

ZeroMemory( &fDIDEVICEOBJECTDATA[pArrayIndex], sizeof(DIDEVICEOBJECTDATA) );
}


// --------------------------------------------------------------------------
// Method:      ClearAll()
// Description: The ClearAll() method can be used to clear the contents of 
//              all the internal DIDEVICEOBJECTDATA structures of the 
//              TDIDeviceObjectData component. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TDIDeviceObjectData::ClearAll()
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDIDeviceObjectData::Clear()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }

ZeroMemory( &fDIDEVICEOBJECTDATA[0], sizeof(DIDEVICEOBJECTDATA)*fArraySize );
}


// --------------------------------------------------------------------------
// Internal Structure Access 
// --------------------------------------------------------------------------
DIDEVICEOBJECTDATA* __fastcall TDIDeviceObjectData::FGetInternal_DIDEVICEOBJECTDATA_Ptr()
{
// check for errors
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDIDeviceObjectData::FGetInternal_DIDEVICEOBJECTDATA_Ptr()", "TDX_ERROR", "Internal Array size is 0." );
    return NULL;
    }
return fDIDEVICEOBJECTDATA;
}
// --------------------------------------------------------------------------
void __fastcall TDIDeviceObjectData::FSetInternal_DIDEVICEOBJECTDATA( dword pArrayIndex, DIDEVICEOBJECTDATA* pDIDEVICEOBJECTDATA )
{
// check for errors
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDIDeviceObjectData::FSetInternal_DIDEVICEOBJECTDATA()", "TDX_ERROR", "Internal Array size is 0." );
    return;
    }
if (pDIDEVICEOBJECTDATA==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDIDeviceObjectData::FSetInternal_DIDEVICEOBJECTDATA()", "TDX_ERROR", "The supplied DIDEVICEOBJECTDATA* was NULL" );
    return;
    }
CopyMemory( &fDIDEVICEOBJECTDATA[pArrayIndex], pDIDEVICEOBJECTDATA, sizeof(DIDEVICEOBJECTDATA) );
Internal_DIDEVICEOBJECTDATA_Update();
}
// --------------------------------------------------------------------------
void __fastcall TDIDeviceObjectData::Internal_DIDEVICEOBJECTDATA_Update()
{
}

// --------------------------------------------------------------------------
