// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDIEffectInfo.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons, website),
//               Brian Austin (some source code, documentation)
// Description:  This file contains the code for the TDIEffectInfo Component 
//
// "TDx_Input_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDIEffectInfo.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Input_Library_Defns"
#pragma link "TDx_Input_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDIEffectInfo*)
{
    new TDIEffectInfo(NULL);
}
// --------------------------------------------------------------------------
namespace Tdieffectinfo
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDIEffectInfo)};
        RegisterComponents("TDx_Input", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDIEffectInfo::TDIEffectInfo()
// Description: The default constructor for the TDIEffectInfo object.
// --------------------------------------------------------------------------
__fastcall TDIEffectInfo::TDIEffectInfo(TComponent* Owner)
    : TComponent(Owner)
{
Clear();
fDynamicParams_Strings=NULL;
fEffectType_Strings=NULL;
fStaticParams_Strings=NULL;
}
// --------------------------------------------------------------------------
// Destructor:  TDIEffectInfo::~TDIEffectInfo()
// Description: The destructor for the TDIEffectInfo object.
// --------------------------------------------------------------------------
__fastcall TDIEffectInfo::~TDIEffectInfo()
{
if (fDynamicParams_Strings!=NULL) delete fDynamicParams_Strings;
if (fEffectType_Strings!=NULL) delete fEffectType_Strings;
if (fStaticParams_Strings!=NULL) delete fStaticParams_Strings;
}
// --------------------------------------------------------------------------
// Property:    DynamicParams
// Description: The DynamicParams property defines flags indicating which 
//              effect parameters can be modified without halting playback. 
//              The properties noted in each flags description may be 
//              modified dynamically when that flag is set. 
//              
//              If an attempt is made to change a property indicated by these 
//              flags while the effect is playing and dynamic modification is 
//              not supported by the driver, then the effect will be stopped, 
//              updated and restarted. 
// Flags:       DIEP_AXES -
//                The TDIEffect::Axes and TDIEffect::AxesCount properties. 
//              DIEP_DIRECTION -
//                The TDIEffect::Direction and TDIEffect::AxesCount 
//                properties. 
//              DIEP_DURATION -
//                The TDIEffect::Duration property. 
//              DIEP_ENVELOPE -
//                The TDIEffect::Envelope property. 
//              DIEP_GAIN -
//                The TDIEffect::Gain property. 
//              DIEP_SAMPLEPERIOD -
//                The TDIEffect::SamplePeriod property. 
//              DIEP_STARTDELAY -
//                The TDIEffect::StartDelay property. 
//              DIEP_TRIGGERBUTTON -
//                The TDIEffect::TriggerButton property. 
//              DIEP_TRIGGERREPEATINTERVAL -
//                The TDIEffect::TriggerRepeatInterval property. 
//              DIEP_TYPESPECIFICPARAMS -
//                The TDIEffect::TypeSpecificParams property. 
// --------------------------------------------------------------------------
dword __fastcall TDIEffectInfo::FGetDynamicParams()
{
return fDIEFFECTINFO.dwDynamicParams;
}
// --------------------------------------------------------------------------
void __fastcall TDIEffectInfo::FSetDynamicParams( dword pDynamicParams )
{
fDIEFFECTINFO.dwDynamicParams = pDynamicParams;
}
// --------------------------------------------------------------------------
// Property:    EffectType
// Description: The EffectType property defines flags indicating the type and 
//              capabilities of an effect or define what effects are to be 
//              enumerated. 
//              The described effect applies when the flag is set. 
//              
//              Type and capability information indicated by the presence of 
//              the flag are described first, then any effect the flag has on 
//              TDx_InputDevice::EnumEffects() is described. 
// Flags:       DIEFT_ALL -
//                All effects should be enumerated, regardless of type. 
//                
//                This flag is only usable with 
//                TDx_InputDevice::EnumEffects() and no other flag may be 
//                used when this one is set. 
//              DIEFT_CONDITION -
//                The effect represents a condition or only conditions are to 
//                be enumerated. 
//                
//                When you are creating or modifying a condition, the 
//                TDIEffect::TypeSpecificParams array must contain one 
//                TDICondition component for each axis affected and 
//                TDIEffect::TypeSpecificParamsSize must be set to a value 
//                equal to TDIEffect::AxesCount multiplied by 
//                sizeof(TDICondition). 
//              DIEFT_CONSTANTFORCE -
//                The effect represents a constant force effect or only 
//                constant force effects are to be enumerated. 
//                
//                When you are creating or modifying a constant force, the 
//                TDIEffect::TypeSpecificParams array must contain one 
//                TDIConstantForce component and 
//                TDIEffect::TypeSpecificParamsSize must be set to 
//                sizeof(TDIConstanForce). 
//              DIEFT_CUSTOMFORCE -
//                The effect represents a custom force effect or only custom 
//                force effects are to be enumerated. 
//                
//                When you are creating or modifying a custom force, the 
//                TDIEffect::TypeSpecificParams array must contain one 
//                TDICustomForce component and 
//                TDIEffect::TypeSpecificParamsSize must be set to 
//                sizeof(TDICustomForce). 
//              DIEFT_DEADBAND -
//                Support for TDICondition::DeadBand is available. 
//              DIEFT_FFATTACK -
//                Support for TDIEnvelope::AttackLevel and 
//                TDIEnvelope::AttackTime is available for this effect.. 
//                
//                When both DIEFT_FFATTACK and DIEFT_FFFADE are both not set, 
//                then envelopes will be ignored for this effect. 
//              DIEFT_FFFADE -
//                Support for TDIEnvelope::FadeLevel and 
//                TDIEnvelope::FadeTime is available for this effect.. 
//                
//                When both DIEFT_FFATTACK and DIEFT_FFFADE are both not set, 
//                then envelopes will be ignored for this effect. 
//              DIEFT_HARDWARE -
//                The effect represents a hardware specific effect or only 
//                hardware specific effects are to be enumerated. 
//                
//                The documentation provided by the device manufacturer 
//                should provide further information about hardware specific 
//                effects. 
//              DIEFT_PERIODIC -
//                The effect represents a periodic effect or only periodic 
//                effects are to be enumerated. 
//                
//                When you are creating or modifying a periodic force, the 
//                TDIEffect::TypeSpecificParams array must contain one 
//                TDIPeriodic component and TDIEffect::TypeSpecificParamsSize 
//                must be set to sizeof(TDIPeriodic). 
//              DIEFT_POSNEGCOEFFICIENTS -
//                Support for both TDICondition::PositiveCoefficient and 
//                TDICondition::NegativeCoefficient is available. 
//                
//                If this flag is not set, TDICondition::PositiveCoefficient 
//                will be used to represent both coefficients. 
//              DIEFT_POSNEGSATURATION -
//                Support for both TDICondition::PositiveSaturation and 
//                TDICondition::NegativeSaturation is available. 
//                
//                If this flag is not set, TDICondition::PositiveSaturation 
//                will be used to represent both saturation values. 
//              DIEFT_RAMPFORCE -
//                The effect represents a ramp force effect or only ramp 
//                force effects are to be enumerated. 
//                
//                When you are creating or modifying a ramp force, the 
//                TDIEffect::TypeSpecificParams array must contain one 
//                TDIRampForce component and 
//                TDIEffect::TypeSpecificParamsSize must be set to 
//                sizeof(TDIRampForce). 
//              DIEFT_SATURATION -
//                Support for saturation of condition effects is available. 
//                
//                When saturation is not supported, both 
//                TDICondition::PositiveSaturation and 
//                TDICondition::NegativeSaturation will be ignored and the 
//                force generated is only limited by the maximum the device 
//                can output. 
// --------------------------------------------------------------------------
dword __fastcall TDIEffectInfo::FGetEffectType()
{
return fDIEFFECTINFO.dwEffType;
}
// --------------------------------------------------------------------------
void __fastcall TDIEffectInfo::FSetEffectType( dword pEffectType )
{
fDIEFFECTINFO.dwEffType = pEffectType;
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDIEffectInfo method or fget/fset. 
//              eg. DI_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDIEffectInfo::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDIEffectInfo::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    Guid
// Description: The Guid property defines a GUID identifying the effect. 
//              
//              Possible values include: 
//              
//              GUID_ConstantForce 
//              GUID_RampForce 
//              GUID_Square 
//              GUID_Sine 
//              GUID_Triangle 
//              GUID_SawtoothUp 
//              GUID_SawtoothDown 
//              GUID_Spring 
//              GUID_Damper 
//              GUID_Inertia 
//              GUID_Friction 
//              GUID_CustomForce 
// --------------------------------------------------------------------------
GUID __fastcall TDIEffectInfo::FGetGuid()
{
return fDIEFFECTINFO.guid;
}
// --------------------------------------------------------------------------
void __fastcall TDIEffectInfo::FSetGuid( GUID pGuid )
{
fDIEFFECTINFO.guid = pGuid;
}
// --------------------------------------------------------------------------
// Property:    Name
// Description: The Name property defines a friendly name for the effect such 
//              as 'Sawtooth up' or 'Constant force'. 
// --------------------------------------------------------------------------
AnsiString __fastcall TDIEffectInfo::FGetName()
{
AnsiString tempName = fDIEFFECTINFO.tszName;
return tempName;
}
// --------------------------------------------------------------------------
void __fastcall TDIEffectInfo::FSetName( AnsiString pName )
{
int max = pName.Length();
if (max>MAX_PATH) max = MAX_PATH;

#ifdef _UNICODE
CopyMemory( &fDIEFFECTINFO.tszName[0], pName.c_str(), max*2 );
#else
CopyMemory( &fDIEFFECTINFO.tszName[0], pName.c_str(), max );
#endif
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property defines the size, in bytes, of the internal 
//              structure used by this component. 
//              
//              This property may be inspected during enumeration to 
//              determine how many properties of the component are valid. 
// --------------------------------------------------------------------------
dword __fastcall TDIEffectInfo::FGetSize()
{
return fDIEFFECTINFO.dwSize;
}
// --------------------------------------------------------------------------
void __fastcall TDIEffectInfo::FSetSize( dword pSize )
{
fDIEFFECTINFO.dwSize = pSize;
}
// --------------------------------------------------------------------------
// Property:    StaticParams
// Description: The StaticParams property defines flags indicating which 
//              parameters of an effect are supported. 
//              The properties noted in each flags description are supported 
//              when that flag is set. 
//              
//              Attempts to use unsupported parameters will not cause errors, 
//              unsupported properties are merely ignored. 
//              These flags can be used to tailor the use of force feedback 
//              to the capabilities of a specific device. 
// --------------------------------------------------------------------------
dword __fastcall TDIEffectInfo::FGetStaticParams()
{
return fDIEFFECTINFO.dwStaticParams;
}
// --------------------------------------------------------------------------
void __fastcall TDIEffectInfo::FSetStaticParams( dword pStaticParams )
{
fDIEFFECTINFO.dwStaticParams = pStaticParams;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TDIEffectInfo's internal DIEFFECTINFO structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TDIEffectInfo::Clear()
{
fDIEFFECTINFO.dwDynamicParams = 0;
fDIEFFECTINFO.dwEffType = 0;
fErrorValue = DI_OK;
ZeroMemory(&fGuid,sizeof(_GUID));
fDIEFFECTINFO.dwSize = sizeof(DIEFFECTINFO);
fDIEFFECTINFO.dwStaticParams = 0;
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
DIEFFECTINFO* __fastcall TDIEffectInfo::FGetInternal_DIEFFECTINFO_Ptr()
{
return &fDIEFFECTINFO;
}
// --------------------------------------------------------------------------
void __fastcall TDIEffectInfo::FSetInternal_DIEFFECTINFO( DIEFFECTINFO* pDIEFFECTINFO )
{
if (pDIEFFECTINFO==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDIEffectInfo::FSetInternal_DIEFFECTINFO()", "TDX_ERROR", "The supplied DIEFFECTINFO* was NULL" );
    return;
    }

CopyMemory( &fDIEFFECTINFO, pDIEFFECTINFO, sizeof(DIEFFECTINFO) );
Internal_DIEFFECTINFO_Update();
}
// --------------------------------------------------------------------------
void __fastcall TDIEffectInfo::Internal_DIEFFECTINFO_Update()
{
}

// --------------------------------------------------------------------------
// Method:      FGetDynamicParams_
// Description: This method returns a TDIEffectInfo_DynamicParams_Set<> of 
//              the flags in the current fDIEFFECTINFO.dwDynamicParams. 
// Note:        Wrapper components use the following method to modify flags 
//              via the BCB Object Inspector. 
// --------------------------------------------------------------------------
TDIEffectInfo_DynamicParams_Set __fastcall TDIEffectInfo::FGetDynamicParams_()
{
TDIEffectInfo_DynamicParams_Set TempDynamicParams_;
TempDynamicParams_.Clear();
if (fDIEFFECTINFO.dwDynamicParams & DIEP_AXES) TempDynamicParams_ = TempDynamicParams_ << diep_axes;
if (fDIEFFECTINFO.dwDynamicParams & DIEP_DIRECTION) TempDynamicParams_ = TempDynamicParams_ << diep_direction;
if (fDIEFFECTINFO.dwDynamicParams & DIEP_DURATION) TempDynamicParams_ = TempDynamicParams_ << diep_duration;
if (fDIEFFECTINFO.dwDynamicParams & DIEP_ENVELOPE) TempDynamicParams_ = TempDynamicParams_ << diep_envelope;
if (fDIEFFECTINFO.dwDynamicParams & DIEP_GAIN) TempDynamicParams_ = TempDynamicParams_ << diep_gain;
if (fDIEFFECTINFO.dwDynamicParams & DIEP_SAMPLEPERIOD) TempDynamicParams_ = TempDynamicParams_ << diep_sampleperiod;
if (fDIEFFECTINFO.dwDynamicParams & DIEP_STARTDELAY) TempDynamicParams_ = TempDynamicParams_ << diep_startdelay;
if (fDIEFFECTINFO.dwDynamicParams & DIEP_TRIGGERBUTTON) TempDynamicParams_ = TempDynamicParams_ << diep_triggerbutton;
if (fDIEFFECTINFO.dwDynamicParams & DIEP_TRIGGERREPEATINTERVAL) TempDynamicParams_ = TempDynamicParams_ << diep_triggerrepeatinterval;
if (fDIEFFECTINFO.dwDynamicParams & DIEP_TYPESPECIFICPARAMS) TempDynamicParams_ = TempDynamicParams_ << diep_typespecificparams;
return TempDynamicParams_;
}
// --------------------------------------------------------------------------
void __fastcall TDIEffectInfo::FSetDynamicParams_( TDIEffectInfo_DynamicParams_Set pDynamicParams_ )
{
fDIEFFECTINFO.dwDynamicParams = 0;
if (pDynamicParams_.Contains(diep_axes)) fDIEFFECTINFO.dwDynamicParams |= DIEP_AXES;
if (pDynamicParams_.Contains(diep_direction)) fDIEFFECTINFO.dwDynamicParams |= DIEP_DIRECTION;
if (pDynamicParams_.Contains(diep_duration)) fDIEFFECTINFO.dwDynamicParams |= DIEP_DURATION;
if (pDynamicParams_.Contains(diep_envelope)) fDIEFFECTINFO.dwDynamicParams |= DIEP_ENVELOPE;
if (pDynamicParams_.Contains(diep_gain)) fDIEFFECTINFO.dwDynamicParams |= DIEP_GAIN;
if (pDynamicParams_.Contains(diep_sampleperiod)) fDIEFFECTINFO.dwDynamicParams |= DIEP_SAMPLEPERIOD;
if (pDynamicParams_.Contains(diep_startdelay)) fDIEFFECTINFO.dwDynamicParams |= DIEP_STARTDELAY;
if (pDynamicParams_.Contains(diep_triggerbutton)) fDIEFFECTINFO.dwDynamicParams |= DIEP_TRIGGERBUTTON;
if (pDynamicParams_.Contains(diep_triggerrepeatinterval)) fDIEFFECTINFO.dwDynamicParams |= DIEP_TRIGGERREPEATINTERVAL;
if (pDynamicParams_.Contains(diep_typespecificparams)) fDIEFFECTINFO.dwDynamicParams |= DIEP_TYPESPECIFICPARAMS;
}
// --------------------------------------------------------------------------
// Method:      FGetDynamicParams_Strings()
//              This method creates and then returns a TStringList containing 
//              the current set of 'DynamicParams' flags. 
// Note:        You must manually delete the retrieved TStringList after use 
//              to avoid memory corruption. 
// --------------------------------------------------------------------------
TStringList* __fastcall TDIEffectInfo::FGetDynamicParams_Strings()
{
// if the strings have not been allocated
if (fDynamicParams_Strings==NULL)
    {
    // attempt to allocate the strings
    fDynamicParams_Strings = new TStringList();
    // if the allocation failed
    if (fDynamicParams_Strings==NULL)
        {
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError(this, "TDIEffectInfo::FGetDynamicParams_Strings()", "TDX_ERROR", "Could not allocate memory used to retrieve various DynamicParams_Strings" );
        return NULL;
        }
    }
fDynamicParams_Strings->Clear();
if (fDIEFFECTINFO.dwDynamicParams & DIEP_AXES) fDynamicParams_Strings->Add("DIEP_AXES");
if (fDIEFFECTINFO.dwDynamicParams & DIEP_DIRECTION) fDynamicParams_Strings->Add("DIEP_DIRECTION");
if (fDIEFFECTINFO.dwDynamicParams & DIEP_DURATION) fDynamicParams_Strings->Add("DIEP_DURATION");
if (fDIEFFECTINFO.dwDynamicParams & DIEP_ENVELOPE) fDynamicParams_Strings->Add("DIEP_ENVELOPE");
if (fDIEFFECTINFO.dwDynamicParams & DIEP_GAIN) fDynamicParams_Strings->Add("DIEP_GAIN");
if (fDIEFFECTINFO.dwDynamicParams & DIEP_SAMPLEPERIOD) fDynamicParams_Strings->Add("DIEP_SAMPLEPERIOD");
if (fDIEFFECTINFO.dwDynamicParams & DIEP_STARTDELAY) fDynamicParams_Strings->Add("DIEP_STARTDELAY");
if (fDIEFFECTINFO.dwDynamicParams & DIEP_TRIGGERBUTTON) fDynamicParams_Strings->Add("DIEP_TRIGGERBUTTON");
if (fDIEFFECTINFO.dwDynamicParams & DIEP_TRIGGERREPEATINTERVAL) fDynamicParams_Strings->Add("DIEP_TRIGGERREPEATINTERVAL");
if (fDIEFFECTINFO.dwDynamicParams & DIEP_TYPESPECIFICPARAMS) fDynamicParams_Strings->Add("DIEP_TYPESPECIFICPARAMS");
return fDynamicParams_Strings;
}
// --------------------------------------------------------------------------
// Method:      FGetEffectType_
// Description: This method returns a TDIEffectInfo_EffectType_Set<> of the 
//              flags in the current fDIEFFECTINFO.dwEffType. 
// Note:        Wrapper components use the following method to modify flags 
//              via the BCB Object Inspector. 
// --------------------------------------------------------------------------
TDIEffectInfo_EffectType_Set __fastcall TDIEffectInfo::FGetEffectType_()
{
TDIEffectInfo_EffectType_Set TempEffectType_;
TempEffectType_.Clear();
if (fDIEFFECTINFO.dwEffType & DIEFT_DEADBAND) TempEffectType_ = TempEffectType_ << dieft_deadband;
if (fDIEFFECTINFO.dwEffType & DIEFT_FFATTACK) TempEffectType_ = TempEffectType_ << dieft_ffattack;
if (fDIEFFECTINFO.dwEffType & DIEFT_FFFADE) TempEffectType_ = TempEffectType_ << dieft_fffade;
if (fDIEFFECTINFO.dwEffType & DIEFT_PERIODIC) TempEffectType_ = TempEffectType_ << dieft_periodic;
if (fDIEFFECTINFO.dwEffType & DIEFT_POSNEGCOEFFICIENTS) TempEffectType_ = TempEffectType_ << dieft_posnegcoefficients;
if (fDIEFFECTINFO.dwEffType & DIEFT_POSNEGSATURATION) TempEffectType_ = TempEffectType_ << dieft_posnegsaturation;
if (fDIEFFECTINFO.dwEffType & DIEFT_SATURATION) TempEffectType_ = TempEffectType_ << dieft_saturation;
return TempEffectType_;
}
// --------------------------------------------------------------------------
void __fastcall TDIEffectInfo::FSetEffectType_( TDIEffectInfo_EffectType_Set pEffectType_ )
{
fDIEFFECTINFO.dwEffType = 0;
if (pEffectType_.Contains(dieft_deadband)) fDIEFFECTINFO.dwEffType |= DIEFT_DEADBAND;
if (pEffectType_.Contains(dieft_ffattack)) fDIEFFECTINFO.dwEffType |= DIEFT_FFATTACK;
if (pEffectType_.Contains(dieft_fffade)) fDIEFFECTINFO.dwEffType |= DIEFT_FFFADE;
if (pEffectType_.Contains(dieft_periodic)) fDIEFFECTINFO.dwEffType |= DIEFT_PERIODIC;
if (pEffectType_.Contains(dieft_posnegcoefficients)) fDIEFFECTINFO.dwEffType |= DIEFT_POSNEGCOEFFICIENTS;
if (pEffectType_.Contains(dieft_posnegsaturation)) fDIEFFECTINFO.dwEffType |= DIEFT_POSNEGSATURATION;
if (pEffectType_.Contains(dieft_saturation)) fDIEFFECTINFO.dwEffType |= DIEFT_SATURATION;
}
// --------------------------------------------------------------------------
// Method:      FGetEffectType_Strings()
//              This method creates and then returns a TStringList containing 
//              the current set of 'EffectType' flags. 
// Note:        You must manually delete the retrieved TStringList after use 
//              to avoid memory corruption. 
// --------------------------------------------------------------------------
TStringList* __fastcall TDIEffectInfo::FGetEffectType_Strings()
{
// if the strings have not been allocated
if (fEffectType_Strings==NULL)
    {
    // attempt to allocate the strings
    fEffectType_Strings = new TStringList();
    // if the allocation failed
    if (fEffectType_Strings==NULL)
        {
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError(this, "TDIEffectInfo::FGetEffectType_Strings()", "TDX_ERROR", "Could not allocate memory used to retrieve various EffectType_Strings" );
        return NULL;
        }
    }
fEffectType_Strings->Clear();
if (fDIEFFECTINFO.dwEffType & DIEFT_DEADBAND) fEffectType_Strings->Add("DIEFT_DEADBAND");
if (fDIEFFECTINFO.dwEffType & DIEFT_FFATTACK) fEffectType_Strings->Add("DIEFT_FFATTACK");
if (fDIEFFECTINFO.dwEffType & DIEFT_FFFADE) fEffectType_Strings->Add("DIEFT_FFFADE");
if (fDIEFFECTINFO.dwEffType & DIEFT_PERIODIC) fEffectType_Strings->Add("DIEFT_PERIODIC");
if (fDIEFFECTINFO.dwEffType & DIEFT_POSNEGCOEFFICIENTS) fEffectType_Strings->Add("DIEFT_POSNEGCOEFFICIENTS");
if (fDIEFFECTINFO.dwEffType & DIEFT_POSNEGSATURATION) fEffectType_Strings->Add("DIEFT_POSNEGSATURATION");
if (fDIEFFECTINFO.dwEffType & DIEFT_SATURATION) fEffectType_Strings->Add("DIEFT_SATURATION");
return fEffectType_Strings;
}
// --------------------------------------------------------------------------
// Method:      FGetStaticParams_
// Description: This method returns a TDIEffectInfo_StaticParams_Set<> of the 
//              flags in the current fDIEFFECTINFO.dwStaticParams. 
// Note:        Wrapper components use the following method to modify flags 
//              via the BCB Object Inspector. 
// --------------------------------------------------------------------------
TDIEffectInfo_DynamicParams_Set __fastcall TDIEffectInfo::FGetStaticParams_()
{
TDIEffectInfo_DynamicParams_Set TempStaticParams_;
TempStaticParams_.Clear();
if (fDIEFFECTINFO.dwStaticParams & DIEP_AXES) TempStaticParams_ = TempStaticParams_ << diep_axes;
if (fDIEFFECTINFO.dwStaticParams & DIEP_DIRECTION) TempStaticParams_ = TempStaticParams_ << diep_direction;
if (fDIEFFECTINFO.dwStaticParams & DIEP_DURATION) TempStaticParams_ = TempStaticParams_ << diep_duration;
if (fDIEFFECTINFO.dwStaticParams & DIEP_ENVELOPE) TempStaticParams_ = TempStaticParams_ << diep_envelope;
if (fDIEFFECTINFO.dwStaticParams & DIEP_GAIN) TempStaticParams_ = TempStaticParams_ << diep_gain;
if (fDIEFFECTINFO.dwStaticParams & DIEP_SAMPLEPERIOD) TempStaticParams_ = TempStaticParams_ << diep_sampleperiod;
if (fDIEFFECTINFO.dwStaticParams & DIEP_STARTDELAY) TempStaticParams_ = TempStaticParams_ << diep_startdelay;
if (fDIEFFECTINFO.dwStaticParams & DIEP_TRIGGERBUTTON) TempStaticParams_ = TempStaticParams_ << diep_triggerbutton;
if (fDIEFFECTINFO.dwStaticParams & DIEP_TRIGGERREPEATINTERVAL) TempStaticParams_ = TempStaticParams_ << diep_triggerrepeatinterval;
if (fDIEFFECTINFO.dwStaticParams & DIEP_TYPESPECIFICPARAMS) TempStaticParams_ = TempStaticParams_ << diep_typespecificparams;
return TempStaticParams_;
}
// --------------------------------------------------------------------------
void __fastcall TDIEffectInfo::FSetStaticParams_( TDIEffectInfo_DynamicParams_Set pStaticParams_ )
{
fDIEFFECTINFO.dwStaticParams = 0;
if (pStaticParams_.Contains(diep_axes)) fDIEFFECTINFO.dwStaticParams |= DIEP_AXES;
if (pStaticParams_.Contains(diep_direction)) fDIEFFECTINFO.dwStaticParams |= DIEP_DIRECTION;
if (pStaticParams_.Contains(diep_duration)) fDIEFFECTINFO.dwStaticParams |= DIEP_DURATION;
if (pStaticParams_.Contains(diep_envelope)) fDIEFFECTINFO.dwStaticParams |= DIEP_ENVELOPE;
if (pStaticParams_.Contains(diep_gain)) fDIEFFECTINFO.dwStaticParams |= DIEP_GAIN;
if (pStaticParams_.Contains(diep_sampleperiod)) fDIEFFECTINFO.dwStaticParams |= DIEP_SAMPLEPERIOD;
if (pStaticParams_.Contains(diep_startdelay)) fDIEFFECTINFO.dwStaticParams |= DIEP_STARTDELAY;
if (pStaticParams_.Contains(diep_triggerbutton)) fDIEFFECTINFO.dwStaticParams |= DIEP_TRIGGERBUTTON;
if (pStaticParams_.Contains(diep_triggerrepeatinterval)) fDIEFFECTINFO.dwStaticParams |= DIEP_TRIGGERREPEATINTERVAL;
if (pStaticParams_.Contains(diep_typespecificparams)) fDIEFFECTINFO.dwStaticParams |= DIEP_TYPESPECIFICPARAMS;
}
// --------------------------------------------------------------------------
// Method:      FGetStaticParams_Strings()
//              This method creates and then returns a TStringList containing 
//              the current set of 'StaticParams' flags. 
// Note:        You must manually delete the retrieved TStringList after use 
//              to avoid memory corruption. 
// --------------------------------------------------------------------------
TStringList* __fastcall TDIEffectInfo::FGetStaticParams_Strings()
{
// if the strings have not been allocated
if (fStaticParams_Strings==NULL)
    {
    // attempt to allocate the strings
    fStaticParams_Strings = new TStringList();
    // if the allocation failed
    if (fStaticParams_Strings==NULL)
        {
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError(this, "TDIEffectInfo::FGetStaticParams_Strings()", "TDX_ERROR", "Could not allocate memory used to retrieve various StaticParams_Strings" );
        return NULL;
        }
    }
fStaticParams_Strings->Clear();
if (fDIEFFECTINFO.dwStaticParams & DIEP_AXES) fStaticParams_Strings->Add("DIEP_AXES");
if (fDIEFFECTINFO.dwStaticParams & DIEP_DIRECTION) fStaticParams_Strings->Add("DIEP_DIRECTION");
if (fDIEFFECTINFO.dwStaticParams & DIEP_DURATION) fStaticParams_Strings->Add("DIEP_DURATION");
if (fDIEFFECTINFO.dwStaticParams & DIEP_ENVELOPE) fStaticParams_Strings->Add("DIEP_ENVELOPE");
if (fDIEFFECTINFO.dwStaticParams & DIEP_GAIN) fStaticParams_Strings->Add("DIEP_GAIN");
if (fDIEFFECTINFO.dwStaticParams & DIEP_SAMPLEPERIOD) fStaticParams_Strings->Add("DIEP_SAMPLEPERIOD");
if (fDIEFFECTINFO.dwStaticParams & DIEP_STARTDELAY) fStaticParams_Strings->Add("DIEP_STARTDELAY");
if (fDIEFFECTINFO.dwStaticParams & DIEP_TRIGGERBUTTON) fStaticParams_Strings->Add("DIEP_TRIGGERBUTTON");
if (fDIEFFECTINFO.dwStaticParams & DIEP_TRIGGERREPEATINTERVAL) fStaticParams_Strings->Add("DIEP_TRIGGERREPEATINTERVAL");
if (fDIEFFECTINFO.dwStaticParams & DIEP_TYPESPECIFICPARAMS) fStaticParams_Strings->Add("DIEP_TYPESPECIFICPARAMS");
return fStaticParams_Strings;
}
// --------------------------------------------------------------------------
