// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDIEnvelope.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons, website),
//               Brian Austin (some source code, documentation)
// Description:  This file contains the code for the TDIEnvelope Component 
//
// "TDx_Input_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDIEnvelope.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Input_Library_Defns"
#pragma link "TDx_Input_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDIEnvelope*)
{
    new TDIEnvelope(NULL);
}
// --------------------------------------------------------------------------
namespace Tdienvelope
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDIEnvelope)};
        RegisterComponents("TDx_Input", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDIEnvelope::TDIEnvelope()
// Description: The default constructor for the TDIEnvelope object.
// --------------------------------------------------------------------------
__fastcall TDIEnvelope::TDIEnvelope(TComponent* Owner)
    : TComponent(Owner)
{
Clear();
}
// --------------------------------------------------------------------------
// Destructor:  TDIEnvelope::~TDIEnvelope()
// Description: The destructor for the TDIEnvelope object.
// --------------------------------------------------------------------------
__fastcall TDIEnvelope::~TDIEnvelope()
{
}
// --------------------------------------------------------------------------
// Property:    AttackLevel
// Description: The AttackLevel property defines the amplitude used at the 
//              start of the envelope. 
//              
//              This value ranges from 0 to 10,000, relative to 0 for 
//              constant forces, or relative to TDIPeriodic::Offset for 
//              periodic forces. 
// --------------------------------------------------------------------------
dword __fastcall TDIEnvelope::FGetAttackLevel()
{
return fDIENVELOPE.dwAttackLevel;
}
// --------------------------------------------------------------------------
void __fastcall TDIEnvelope::FSetAttackLevel( dword pAttackLevel )
{
fDIENVELOPE.dwAttackLevel = pAttackLevel;
}
// --------------------------------------------------------------------------
// Property:    AttackTime
// Description: The AttackTime property defines the time, in microseconds, it 
//              takes for the effect to reach the sustain level. 
// --------------------------------------------------------------------------
dword __fastcall TDIEnvelope::FGetAttackTime()
{
return fDIENVELOPE.dwAttackTime;
}
// --------------------------------------------------------------------------
void __fastcall TDIEnvelope::FSetAttackTime( dword pAttackTime )
{
fDIENVELOPE.dwAttackTime = pAttackTime;
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDIEnvelope method or fget/fset. 
//              eg. DI_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDIEnvelope::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDIEnvelope::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    FadeLevel
// Description: The FadeLevel property defines the amplitude used at the end 
//              of the envelope. 
//              
//              This value ranges from 0 to 10,000 relative to 0 for constant 
//              forces or to TDIPeriodic::Offset for periodic forces. 
// --------------------------------------------------------------------------
dword __fastcall TDIEnvelope::FGetFadeLevel()
{
return fDIENVELOPE.dwFadeLevel;
}
// --------------------------------------------------------------------------
void __fastcall TDIEnvelope::FSetFadeLevel( dword pFadeLevel )
{
fDIENVELOPE.dwFadeLevel = pFadeLevel;
}
// --------------------------------------------------------------------------
// Property:    FadeTime
// Description: The FadeTime property defines the time, in microseconds, it 
//              takes for the effect to reach the fade level. 
// --------------------------------------------------------------------------
dword __fastcall TDIEnvelope::FGetFadeTime()
{
return fDIENVELOPE.dwFadeTime;
}
// --------------------------------------------------------------------------
void __fastcall TDIEnvelope::FSetFadeTime( dword pFadeTime )
{
fDIENVELOPE.dwFadeTime = pFadeTime;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property defines the size, in bytes, of the internal 
//              structure used by this component. 
// --------------------------------------------------------------------------
dword __fastcall TDIEnvelope::FGetSize()
{
return fDIENVELOPE.dwSize;
}
// --------------------------------------------------------------------------
void __fastcall TDIEnvelope::FSetSize( dword pSize )
{
fDIENVELOPE.dwSize = pSize;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TDIEnvelope's internal DIENVELOPE structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TDIEnvelope::Clear()
{
fDIENVELOPE.dwAttackLevel = 0;
fDIENVELOPE.dwAttackTime = 0;
fErrorValue = DI_OK;
fDIENVELOPE.dwFadeLevel = 0;
fDIENVELOPE.dwFadeTime = 0;
fDIENVELOPE.dwSize = sizeof(DIENVELOPE);
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
DIENVELOPE* __fastcall TDIEnvelope::FGetInternal_DIENVELOPE_Ptr()
{
return &fDIENVELOPE;
}
// --------------------------------------------------------------------------
void __fastcall TDIEnvelope::FSetInternal_DIENVELOPE( DIENVELOPE* pDIENVELOPE )
{
if (pDIENVELOPE==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDIEnvelope::FSetInternal_DIENVELOPE()", "TDX_ERROR", "The supplied DIENVELOPE* was NULL" );
    return;
    }

CopyMemory( &fDIENVELOPE, pDIENVELOPE, sizeof(DIENVELOPE) );
Internal_DIENVELOPE_Update();
}
// --------------------------------------------------------------------------
void __fastcall TDIEnvelope::Internal_DIENVELOPE_Update()
{
}

// --------------------------------------------------------------------------
