// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDIJoyState2.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons, website),
//               Brian Austin (some source code, documentation)
// Description:  This file contains the code for the TDIJoyState2 Component 
//
// "TDx_Input_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDIJoyState2.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Input_Library_Defns"
#pragma link "TDx_Input_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDIJoyState2*)
{
    new TDIJoyState2(NULL);
}
// --------------------------------------------------------------------------
namespace Tdijoystate2
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDIJoyState2)};
        RegisterComponents("TDx_Input", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDIJoyState2::TDIJoyState2()
// Description: The default constructor for the TDIJoyState2 object.
// --------------------------------------------------------------------------
__fastcall TDIJoyState2::TDIJoyState2(TComponent* Owner)
    : TDIData(Owner)
{
Clear();
}
// --------------------------------------------------------------------------
// Destructor:  TDIJoyState2::~TDIJoyState2()
// Description: The destructor for the TDIJoyState2 object.
// --------------------------------------------------------------------------
__fastcall TDIJoyState2::~TDIJoyState2()
{
}
// --------------------------------------------------------------------------
// Property:    ARX
// Description: The ARX property describes the angular acceleration around 
//              the joysticks X axis. 
//              
//              When angular acceleration is unsupported, this value will be 
//              0. 
// --------------------------------------------------------------------------
long __fastcall TDIJoyState2::FGetARX()
{
return fDIJOYSTATE2.lARx;
}
// --------------------------------------------------------------------------
void __fastcall TDIJoyState2::FSetARX( long pARX )
{
fDIJOYSTATE2.lARx = pARX;
}
// --------------------------------------------------------------------------
// Property:    ARY
// Description: The ARY property describes the angular acceleration around 
//              the joysticks Y axis. 
//              
//              When angular acceleration is unsupported, this value will be 
//              0. 
// --------------------------------------------------------------------------
long __fastcall TDIJoyState2::FGetARY()
{
return fDIJOYSTATE2.lARy;
}
// --------------------------------------------------------------------------
void __fastcall TDIJoyState2::FSetARY( long pARY )
{
fDIJOYSTATE2.lARy = pARY;
}
// --------------------------------------------------------------------------
// Property:    ARZ
// Description: The ARZ property describes the angular acceleration around 
//              the joysticks Z axis. 
//              
//              When angular acceleration is unsupported or there is no Z 
//              axis, this value will be 0. 
// --------------------------------------------------------------------------
long __fastcall TDIJoyState2::FGetARZ()
{
return fDIJOYSTATE2.lARz;
}
// --------------------------------------------------------------------------
void __fastcall TDIJoyState2::FSetARZ( long pARZ )
{
fDIJOYSTATE2.lARz = pARZ;
}
// --------------------------------------------------------------------------
// Property:    ASlider
// Description: The ASlider property defines an long array describing 
//              acceration along the two additional axes described in 
//              TDIJoystate2::Slider. 
// --------------------------------------------------------------------------
long __fastcall TDIJoyState2::FGetASlider( dword pIndex )
{
if (pIndex>=2)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDIJoyState2::FGetASlider()", "TDX_ERROR", "'pIndex' parameter is out of bounds." );
    return (LONG) NULL;
    }
return fDIJOYSTATE2.rglASlider[pIndex];
}
// --------------------------------------------------------------------------
void __fastcall TDIJoyState2::FSetASlider( dword pIndex, long pASlider )
{
fDIJOYSTATE2.rglASlider[pIndex] = pASlider;
}
// --------------------------------------------------------------------------
// Property:    AX
// Description: The AX property describes acceleration along the joysticks X 
//              axis. 
//              
//              When acceleration is unsupported, this value will be 0. 
// --------------------------------------------------------------------------
long __fastcall TDIJoyState2::FGetAX()
{
return fDIJOYSTATE2.lAX;
}
// --------------------------------------------------------------------------
void __fastcall TDIJoyState2::FSetAX( long pAX )
{
fDIJOYSTATE2.lAX = pAX;
}
// --------------------------------------------------------------------------
// Property:    AY
// Description: The AY property describes acceleration along the joysticks Y 
//              axis. 
//              
//              When acceleration is unsupported, this value will be 0. 
// --------------------------------------------------------------------------
long __fastcall TDIJoyState2::FGetAY()
{
return fDIJOYSTATE2.lAY;
}
// --------------------------------------------------------------------------
void __fastcall TDIJoyState2::FSetAY( long pAY )
{
fDIJOYSTATE2.lAY = pAY;
}
// --------------------------------------------------------------------------
// Property:    AZ
// Description: The AZ property describes acceleration along the joysticks Z 
//              axis. 
//              
//              When acceleration is unsupported or there is no Z axis, this 
//              value will be 0. 
// --------------------------------------------------------------------------
long __fastcall TDIJoyState2::FGetAZ()
{
return fDIJOYSTATE2.lAZ;
}
// --------------------------------------------------------------------------
void __fastcall TDIJoyState2::FSetAZ( long pAZ )
{
fDIJOYSTATE2.lAZ = pAZ;
}
// --------------------------------------------------------------------------
// Property:    Buttons
// Description: The Buttons property defines a byte array of up to 128 button 
//              states. 
//              
//              When a given button is down, the high-order bit of the 
//              corresponding byte will be set. 
//              If the button is up, or does not exist, the bit will be 
//              clear. 
// --------------------------------------------------------------------------
byte __fastcall TDIJoyState2::FGetButtons( dword pIndex )
{
if (pIndex>=128)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDIJoyState2::FGetButtons()", "TDX_ERROR", "'pIndex' parameter is out of bounds." );
    return (BYTE) NULL;
    }
return fDIJOYSTATE2.rgbButtons[pIndex];
}
// --------------------------------------------------------------------------
void __fastcall TDIJoyState2::FSetButtons( dword pIndex, byte pButtons )
{
fDIJOYSTATE2.rgbButtons[pIndex] = pButtons;
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDIJoyState2 method or fget/fset. 
//              eg. DI_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDIJoyState2::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDIJoyState2::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    FRX
// Description: The FRX property describes the rotational force (torque) on 
//              the joysticks X axis. 
//              
//              When torque is unsupported, this value will be 0. 
// --------------------------------------------------------------------------
long __fastcall TDIJoyState2::FGetFRX()
{
return fDIJOYSTATE2.lFRx;
}
// --------------------------------------------------------------------------
void __fastcall TDIJoyState2::FSetFRX( long pFRX )
{
fDIJOYSTATE2.lFRx = pFRX;
}
// --------------------------------------------------------------------------
// Property:    FRY
// Description: The FRY property describes the rotational force (torque) on 
//              the joysticks Y axis. 
//              
//              When torque is unsupported, this value will be 0. 
// --------------------------------------------------------------------------
long __fastcall TDIJoyState2::FGetFRY()
{
return fDIJOYSTATE2.lFRy;
}
// --------------------------------------------------------------------------
void __fastcall TDIJoyState2::FSetFRY( long pFRY )
{
fDIJOYSTATE2.lFRy = pFRY;
}
// --------------------------------------------------------------------------
// Property:    FRZ
// Description: The FRZ property describes the rotational force (torque) on 
//              the joysticks Z axis. 
//              
//              When torque is unsupported or there is no Z axis, this value 
//              will be 0. 
// --------------------------------------------------------------------------
long __fastcall TDIJoyState2::FGetFRZ()
{
return fDIJOYSTATE2.lFRz;
}
// --------------------------------------------------------------------------
void __fastcall TDIJoyState2::FSetFRZ( long pFRZ )
{
fDIJOYSTATE2.lFRz = pFRZ;
}
// --------------------------------------------------------------------------
// Property:    FSlider
// Description: The FSlider property defines an long array describing the 
//              force on the two additional axes described in 
//              TDIJoystate2::Slider. 
// --------------------------------------------------------------------------
long __fastcall TDIJoyState2::FGetFSlider( dword pIndex )
{
if (pIndex>=2)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDIJoyState2::FGetFSlider()", "TDX_ERROR", "'pIndex' parameter is out of bounds." );
    return (LONG) NULL;
    }
return fDIJOYSTATE2.rglFSlider[pIndex];
}
// --------------------------------------------------------------------------
void __fastcall TDIJoyState2::FSetFSlider( dword pIndex, long pFSlider )
{
fDIJOYSTATE2.rglFSlider[pIndex] = pFSlider;
}
// --------------------------------------------------------------------------
// Property:    FX
// Description: The FX property describes the force on the joysticks X axis. 
//              
//              When force is unsupported, this value will be 0. 
// --------------------------------------------------------------------------
long __fastcall TDIJoyState2::FGetFX()
{
return fDIJOYSTATE2.lFX;
}
// --------------------------------------------------------------------------
void __fastcall TDIJoyState2::FSetFX( long pFX )
{
fDIJOYSTATE2.lFX = pFX;
}
// --------------------------------------------------------------------------
// Property:    FY
// Description: The FY property describes the force on the joysticks Y axis. 
//              
//              When force is unsupported, this value will be 0. 
// --------------------------------------------------------------------------
long __fastcall TDIJoyState2::FGetFY()
{
return fDIJOYSTATE2.lFY;
}
// --------------------------------------------------------------------------
void __fastcall TDIJoyState2::FSetFY( long pFY )
{
fDIJOYSTATE2.lFY = pFY;
}
// --------------------------------------------------------------------------
// Property:    FZ
// Description: The FZ property describes the force on the joysticks Z axis. 
//              
//              When force is unsupported or there is no Z axis, this value 
//              will be 0. 
// --------------------------------------------------------------------------
long __fastcall TDIJoyState2::FGetFZ()
{
return fDIJOYSTATE2.lFZ;
}
// --------------------------------------------------------------------------
void __fastcall TDIJoyState2::FSetFZ( long pFZ )
{
fDIJOYSTATE2.lFZ = pFZ;
}
// --------------------------------------------------------------------------
// Property:    POV
// Description: The POV property defines a dword array indicating the 
//              position, in 100ths of a degree, of up to 4 direction 
//              controllers such as Point Of View hats. 
//              
//              Direction is measured clockwise from directly away from the 
//              user and the centered position is reported as -1 or 65535. 
//              
//              Thus, for an indicator with five positions, it could have a 
//              value of -1(or 65535) (centered), 0 (away from user), 9,000 
//              (to the right), 18,000 (towards the user), or 27,000 (to the 
//              left). 
// --------------------------------------------------------------------------
dword __fastcall TDIJoyState2::FGetPOV( dword pIndex )
{
if (pIndex>=4)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDIJoyState2::FGetPOV()", "TDX_ERROR", "'pIndex' parameter is out of bounds." );
    return (DWORD) NULL;
    }
return fDIJOYSTATE2.rgdwPOV[pIndex];
}
// --------------------------------------------------------------------------
void __fastcall TDIJoyState2::FSetPOV( dword pIndex, dword pPOV )
{
fDIJOYSTATE2.rgdwPOV[pIndex] = pPOV;
}
// --------------------------------------------------------------------------
// Property:    RX
// Description: The RX property describes the rotation of the joysticks X 
//              axis. 
//              
//              When rotation is unsupported, this value will be 0. 
// --------------------------------------------------------------------------
long __fastcall TDIJoyState2::FGetRX()
{
return fDIJOYSTATE2.lRx;
}
// --------------------------------------------------------------------------
void __fastcall TDIJoyState2::FSetRX( long pRX )
{
fDIJOYSTATE2.lRx = pRX;
}
// --------------------------------------------------------------------------
// Property:    RY
// Description: The RY property describes the rotation of the joysticks Y 
//              axis. 
//              
//              When rotation is unsupported, this value will be 0. 
// --------------------------------------------------------------------------
long __fastcall TDIJoyState2::FGetRY()
{
return fDIJOYSTATE2.lRy;
}
// --------------------------------------------------------------------------
void __fastcall TDIJoyState2::FSetRY( long pRY )
{
fDIJOYSTATE2.lRy = pRY;
}
// --------------------------------------------------------------------------
// Property:    RZ
// Description: The RZ property describes the rotation of the joysticks Z 
//              axis. 
//              
//              When rotation is unsupported or there is no Z axis, this 
//              value will be 0. 
// --------------------------------------------------------------------------
long __fastcall TDIJoyState2::FGetRZ()
{
return fDIJOYSTATE2.lRz;
}
// --------------------------------------------------------------------------
void __fastcall TDIJoyState2::FSetRZ( long pRZ )
{
fDIJOYSTATE2.lRz = pRZ;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property contains the size in bytes of the internal 
//              DIJOYSTATE2 structure. 
// --------------------------------------------------------------------------
dword __fastcall TDIJoyState2::FGetSize()
{
return fSize;
}
// --------------------------------------------------------------------------
void __fastcall TDIJoyState2::FSetSize( dword pSize )
{
fSize = pSize;
}
// --------------------------------------------------------------------------
// Property:    Slider
// Description: The Slider property defines an long array describing two 
//              additional axis values whose semantics depend on the specific 
//              joystick being used. 
//              
//              TDx_InputDevice::GetObjectInfo() can be used to obtain 
//              semantic information about these axes, which were formally 
//              called the U and V axes. 
// --------------------------------------------------------------------------
long __fastcall TDIJoyState2::FGetSlider( dword pIndex )
{
if (pIndex>=2)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDIJoyState2::FGetSlider()", "TDX_ERROR", "'pIndex' parameter is out of bounds." );
    return (LONG) NULL;
    }
return fDIJOYSTATE2.rglSlider[pIndex];
}
// --------------------------------------------------------------------------
void __fastcall TDIJoyState2::FSetSlider( dword pIndex, long pSlider )
{
fDIJOYSTATE2.rglSlider[pIndex] = pSlider;
}
// --------------------------------------------------------------------------
// Property:    VRX
// Description: The VRX property describes the angular velocity around the 
//              joysticks X axis. 
//              
//              When angular velocity is unsupported, this value will be 0. 
// --------------------------------------------------------------------------
long __fastcall TDIJoyState2::FGetVRX()
{
return fDIJOYSTATE2.lVRx;
}
// --------------------------------------------------------------------------
void __fastcall TDIJoyState2::FSetVRX( long pVRX )
{
fDIJOYSTATE2.lVRx = pVRX;
}
// --------------------------------------------------------------------------
// Property:    VRY
// Description: The VRY property describes the angular velocity around the 
//              joysticks Y axis. 
//              
//              When angular velocity is unsupported, this value will be 0. 
// --------------------------------------------------------------------------
long __fastcall TDIJoyState2::FGetVRY()
{
return fDIJOYSTATE2.lVRy;
}
// --------------------------------------------------------------------------
void __fastcall TDIJoyState2::FSetVRY( long pVRY )
{
fDIJOYSTATE2.lVRy = pVRY;
}
// --------------------------------------------------------------------------
// Property:    VRZ
// Description: The VRZ property describes the angular velocity around the 
//              joysticks Z axis. 
//              
//              When angular velocity is unsupported or there is no Z axis, 
//              this value will be 0. 
// --------------------------------------------------------------------------
long __fastcall TDIJoyState2::FGetVRZ()
{
return fDIJOYSTATE2.lVRz;
}
// --------------------------------------------------------------------------
void __fastcall TDIJoyState2::FSetVRZ( long pVRZ )
{
fDIJOYSTATE2.lVRz = pVRZ;
}
// --------------------------------------------------------------------------
// Property:    VSlider
// Description: The VSlider property defines an long array describing 
//              velocity along the two additional axes described in 
//              TDIJoystate2::Slider. 
// --------------------------------------------------------------------------
long __fastcall TDIJoyState2::FGetVSlider( dword pIndex )
{
if (pIndex>=2)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDIJoyState2::FGetVSlider()", "TDX_ERROR", "'pIndex' parameter is out of bounds." );
    return (LONG) NULL;
    }
return fDIJOYSTATE2.rglVSlider[pIndex];
}
// --------------------------------------------------------------------------
void __fastcall TDIJoyState2::FSetVSlider( dword pIndex, long pVSlider )
{
fDIJOYSTATE2.rglVSlider[pIndex] = pVSlider;
}
// --------------------------------------------------------------------------
// Property:    VX
// Description: The VX property describes the velocity along the joysticks X 
//              axis. 
//              
//              When velocity is unsupported, this value will be 0. 
// --------------------------------------------------------------------------
long __fastcall TDIJoyState2::FGetVX()
{
return fDIJOYSTATE2.lVX;
}
// --------------------------------------------------------------------------
void __fastcall TDIJoyState2::FSetVX( long pVX )
{
fDIJOYSTATE2.lVX = pVX;
}
// --------------------------------------------------------------------------
// Property:    VY
// Description: The VY property describes the velocity along the joysticks Y 
//              axis. 
//              
//              When velocity is unsupported, this value will be 0. 
//              
// --------------------------------------------------------------------------
long __fastcall TDIJoyState2::FGetVY()
{
return fDIJOYSTATE2.lVY;
}
// --------------------------------------------------------------------------
void __fastcall TDIJoyState2::FSetVY( long pVY )
{
fDIJOYSTATE2.lVY = pVY;
}
// --------------------------------------------------------------------------
// Property:    VZ
// Description: The VZ property describes the velocity along the joysticks Z 
//              axis. 
//              
//              When velocity is unsupported or there is no Z axis, this 
//              value will be 0. 
// --------------------------------------------------------------------------
long __fastcall TDIJoyState2::FGetVZ()
{
return fDIJOYSTATE2.lVZ;
}
// --------------------------------------------------------------------------
void __fastcall TDIJoyState2::FSetVZ( long pVZ )
{
fDIJOYSTATE2.lVZ = pVZ;
}
// --------------------------------------------------------------------------
// Property:    X
// Description: The X property describes position information for the 
//              joysticks X axis. 
//              
//              This axis usually represents the left right movement of a 
//              control stick. 
// --------------------------------------------------------------------------
long __fastcall TDIJoyState2::FGetX()
{
return fDIJOYSTATE2.lX;
}
// --------------------------------------------------------------------------
void __fastcall TDIJoyState2::FSetX( long pX )
{
fDIJOYSTATE2.lX = pX;
}
// --------------------------------------------------------------------------
// Property:    Y
// Description: The Y property describes position information for the 
//              joysticks Y axis. 
//              
//              This axis usually represents the backward forward movement of 
//              a control stick. 
// --------------------------------------------------------------------------
long __fastcall TDIJoyState2::FGetY()
{
return fDIJOYSTATE2.lY;
}
// --------------------------------------------------------------------------
void __fastcall TDIJoyState2::FSetY( long pY )
{
fDIJOYSTATE2.lY = pY;
}
// --------------------------------------------------------------------------
// Property:    Z
// Description: The Z property describes position information for the 
//              joysticks Z axis. 
//              
//              This axis often represents a throttle control of a joystick. 
//              If there is no Z axis, this value will be 0. 
// --------------------------------------------------------------------------
long __fastcall TDIJoyState2::FGetZ()
{
return fDIJOYSTATE2.lZ;
}
// --------------------------------------------------------------------------
void __fastcall TDIJoyState2::FSetZ( long pZ )
{
fDIJOYSTATE2.lZ = pZ;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TDIJoyState2's internal DIJOYSTATE2 structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TDIJoyState2::Clear()
{
fDIJOYSTATE2.lARx = 0;
fDIJOYSTATE2.lARy = 0;
fDIJOYSTATE2.lARz = 0;
for (int ASlider_index=0;ASlider_index<2;ASlider_index++) fDIJOYSTATE2.rglASlider[ASlider_index] = 0;
fDIJOYSTATE2.lAX = 0;
fDIJOYSTATE2.lAY = 0;
fDIJOYSTATE2.lAZ = 0;
for (int Buttons_index=0;Buttons_index<128;Buttons_index++) fDIJOYSTATE2.rgbButtons[Buttons_index] = 0;
fErrorValue = DI_OK;
fDIJOYSTATE2.lFRx = 0;
fDIJOYSTATE2.lFRy = 0;
fDIJOYSTATE2.lFRz = 0;
for (int FSlider_index=0;FSlider_index<2;FSlider_index++) fDIJOYSTATE2.rglFSlider[FSlider_index] = 0;
fDIJOYSTATE2.lFX = 0;
fDIJOYSTATE2.lFY = 0;
fDIJOYSTATE2.lFZ = 0;
for (int POV_index=0;POV_index<4;POV_index++) fDIJOYSTATE2.rgdwPOV[POV_index] = 0;
fDIJOYSTATE2.lRx = 0;
fDIJOYSTATE2.lRy = 0;
fDIJOYSTATE2.lRz = 0;
fSize = sizeof(DIJOYSTATE2);
for (int Slider_index=0;Slider_index<2;Slider_index++) fDIJOYSTATE2.rglSlider[Slider_index] = 0;
fDIJOYSTATE2.lVRx = 0;
fDIJOYSTATE2.lVRy = 0;
fDIJOYSTATE2.lVRz = 0;
for (int VSlider_index=0;VSlider_index<2;VSlider_index++) fDIJOYSTATE2.rglVSlider[VSlider_index] = 0;
fDIJOYSTATE2.lVX = 0;
fDIJOYSTATE2.lVY = 0;
fDIJOYSTATE2.lVZ = 0;
fDIJOYSTATE2.lX = 0;
fDIJOYSTATE2.lY = 0;
fDIJOYSTATE2.lZ = 0;
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
DIJOYSTATE2* __fastcall TDIJoyState2::FGetInternal_DIJOYSTATE2_Ptr()
{
return &fDIJOYSTATE2;
}
// --------------------------------------------------------------------------
void __fastcall TDIJoyState2::FSetInternal_DIJOYSTATE2( DIJOYSTATE2* pDIJOYSTATE2 )
{
if (pDIJOYSTATE2==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDIJoyState2::FSetInternal_DIJOYSTATE2()", "TDX_ERROR", "The supplied DIJOYSTATE2* was NULL" );
    return;
    }

CopyMemory( &fDIJOYSTATE2, pDIJOYSTATE2, sizeof(DIJOYSTATE2) );
Internal_DIJOYSTATE2_Update();
}
// --------------------------------------------------------------------------
void __fastcall TDIJoyState2::Internal_DIJOYSTATE2_Update()
{
}

// --------------------------------------------------------------------------
