// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDIMouseState2.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons, website),
//               Brian Austin (some source code, documentation)
// Description:  This file contains the code for the TDIMouseState2 Component 
//
// "TDx_Input_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDIMouseState2.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Input_Library_Defns"
#pragma link "TDx_Input_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDIMouseState2*)
{
    new TDIMouseState2(NULL);
}
// --------------------------------------------------------------------------
namespace Tdimousestate2
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDIMouseState2)};
        RegisterComponents("TDx_Input", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDIMouseState2::TDIMouseState2()
// Description: The default constructor for the TDIMouseState2 object.
// --------------------------------------------------------------------------
__fastcall TDIMouseState2::TDIMouseState2(TComponent* Owner)
    : TDIData(Owner)
{
Clear();
}
// --------------------------------------------------------------------------
// Destructor:  TDIMouseState2::~TDIMouseState2()
// Description: The destructor for the TDIMouseState2 object.
// --------------------------------------------------------------------------
__fastcall TDIMouseState2::~TDIMouseState2()
{
}
// --------------------------------------------------------------------------
// Property:    Buttons
// Description: The Buttons property defines a byte array of up to 8 button 
//              states. 
//              
//              When a given button is down, the high-order bit of the 
//              corresponding byte will be set. 
//              If the button is up, or does not exist, the bit will be 
//              clear. 
// --------------------------------------------------------------------------
byte __fastcall TDIMouseState2::FGetButtons( dword pIndex )
{
if (pIndex>=8)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDIMouseState2::FGetButtons()", "TDX_ERROR", "'pIndex' parameter is out of bounds." );
    return (BYTE) NULL;
    }
return fDIMOUSESTATE2.rgbButtons[pIndex];
}
// --------------------------------------------------------------------------
void __fastcall TDIMouseState2::FSetButtons( dword pIndex, byte pButtons )
{
fDIMOUSESTATE2.rgbButtons[pIndex] = pButtons;
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDIMouseState2 method or fget/fset. 
//              eg. DI_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDIMouseState2::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDIMouseState2::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property contains the size in bytes of the internal 
//              DIMOUSESTATE2 structure. 
// --------------------------------------------------------------------------
dword __fastcall TDIMouseState2::FGetSize()
{
return fSize;
}
// --------------------------------------------------------------------------
void __fastcall TDIMouseState2::FSetSize( dword pSize )
{
fSize = pSize;
}
// --------------------------------------------------------------------------
// Property:    X
// Description: The X property describes movement of the mouse's X axis, 
//              which usually represents the left right movement of the 
//              mouse. 
// --------------------------------------------------------------------------
long __fastcall TDIMouseState2::FGetX()
{
return fDIMOUSESTATE2.lX;
}
// --------------------------------------------------------------------------
void __fastcall TDIMouseState2::FSetX( long pX )
{
fDIMOUSESTATE2.lX = pX;
}
// --------------------------------------------------------------------------
// Property:    Y
// Description: The Y property describes movement of the mouse's Y axis, 
//              which usually represents the forward backward movement of the 
//              mouse. 
// --------------------------------------------------------------------------
long __fastcall TDIMouseState2::FGetY()
{
return fDIMOUSESTATE2.lY;
}
// --------------------------------------------------------------------------
void __fastcall TDIMouseState2::FSetY( long pY )
{
fDIMOUSESTATE2.lY = pY;
}
// --------------------------------------------------------------------------
// Property:    Z
// Description: The Z property describes movement of the mouse's Z axis, 
//              which is usually a wheel between the buttons. 
//              
//              When there is no Z axis, this value will be 0. 
// --------------------------------------------------------------------------
long __fastcall TDIMouseState2::FGetZ()
{
return fDIMOUSESTATE2.lZ;
}
// --------------------------------------------------------------------------
void __fastcall TDIMouseState2::FSetZ( long pZ )
{
fDIMOUSESTATE2.lZ = pZ;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TDIMouseState2's internal DIMOUSESTATE2 structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TDIMouseState2::Clear()
{
for (int Buttons_index=0;Buttons_index<8;Buttons_index++) fDIMOUSESTATE2.rgbButtons[Buttons_index] = 0;
fErrorValue = DI_OK;
fSize = sizeof(DIMOUSESTATE2);
fDIMOUSESTATE2.lX = 0;
fDIMOUSESTATE2.lY = 0;
fDIMOUSESTATE2.lZ = 0;
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
DIMOUSESTATE2* __fastcall TDIMouseState2::FGetInternal_DIMOUSESTATE2_Ptr()
{
return &fDIMOUSESTATE2;
}
// --------------------------------------------------------------------------
void __fastcall TDIMouseState2::FSetInternal_DIMOUSESTATE2( DIMOUSESTATE2* pDIMOUSESTATE2 )
{
if (pDIMOUSESTATE2==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDIMouseState2::FSetInternal_DIMOUSESTATE2()", "TDX_ERROR", "The supplied DIMOUSESTATE2* was NULL" );
    return;
    }

CopyMemory( &fDIMOUSESTATE2, pDIMOUSESTATE2, sizeof(DIMOUSESTATE2) );
Internal_DIMOUSESTATE2_Update();
}
// --------------------------------------------------------------------------
void __fastcall TDIMouseState2::Internal_DIMOUSESTATE2_Update()
{
}

// --------------------------------------------------------------------------
