// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDIPeriodic.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons, website),
//               Brian Austin (some source code, documentation)
// Description:  This file contains the code for the TDIPeriodic Component 
//
// "TDx_Input_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDIPeriodic.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Input_Library_Defns"
#pragma link "TDx_Input_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDIPeriodic*)
{
    new TDIPeriodic(NULL);
}
// --------------------------------------------------------------------------
namespace Tdiperiodic
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDIPeriodic)};
        RegisterComponents("TDx_Input", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDIPeriodic::TDIPeriodic()
// Description: The default constructor for the TDIPeriodic object.
// --------------------------------------------------------------------------
__fastcall TDIPeriodic::TDIPeriodic(TComponent* Owner)
    : TDIForce(Owner)
{
Clear();
}
// --------------------------------------------------------------------------
// Destructor:  TDIPeriodic::~TDIPeriodic()
// Description: The destructor for the TDIPeriodic object.
// --------------------------------------------------------------------------
__fastcall TDIPeriodic::~TDIPeriodic()
{
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDIPeriodic method or fget/fset. 
//              eg. DI_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDIPeriodic::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDIPeriodic::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    Magnitude
// Description: The Magnitude property defines the maximum amplitude of the 
//              waveform from the TDIPeriodic::Offset value. 
//              
//              This value is in a range from 0, representing no force output 
//              at all, to 10,000, representing the maximum force output 
//              possible and represents the sustain magnitude if an envelope 
//              is being used. 
// --------------------------------------------------------------------------
dword __fastcall TDIPeriodic::FGetMagnitude()
{
return fDIPERIODIC.dwMagnitude;
}
// --------------------------------------------------------------------------
void __fastcall TDIPeriodic::FSetMagnitude( dword pMagnitude )
{
fDIPERIODIC.dwMagnitude = pMagnitude;
}
// --------------------------------------------------------------------------
// Property:    Offset
// Description: The Offset property defines the offset for the effect, which 
//              represents a baseline to which the value of 
//              TDIPeriodic::Magnitude is applied in both directions to 
//              establish the actual directional force outputs for the 
//              effect. 
//              
//              This value can range from -10,000 to 10,000, the extreme 
//              values representing the maximum force output the device is 
//              capable of in the positive and negative directions. 
//              
//              For example, an offset of 2000 and a magnitude of 5000 for a 
//              periodic effect along the X axis would result in a force that 
//              oscillates between 7000 and -3000. 
// --------------------------------------------------------------------------
long __fastcall TDIPeriodic::FGetOffset()
{
return fDIPERIODIC.lOffset;
}
// --------------------------------------------------------------------------
void __fastcall TDIPeriodic::FSetOffset( long pOffset )
{
fDIPERIODIC.lOffset = pOffset;
}
// --------------------------------------------------------------------------
// Property:    Period
// Description: The Period property defines the how long, in microseconds, 
//              the waveform will take to do one complete cycle. 
// --------------------------------------------------------------------------
dword __fastcall TDIPeriodic::FGetPeriod()
{
return fDIPERIODIC.dwPeriod;
}
// --------------------------------------------------------------------------
void __fastcall TDIPeriodic::FSetPeriod( dword pPeriod )
{
fDIPERIODIC.dwPeriod = pPeriod;
}
// --------------------------------------------------------------------------
// Property:    Phase
// Description: The Phase property defines the position, in 100ths of a 
//              degree, in the waveform at which playback begins. 
//              
//              This property has a range of 0 to 35999 but all values may 
//              not be supported, in which case it will be rounded to the 
//              nearest value that is supported. 
// --------------------------------------------------------------------------
dword __fastcall TDIPeriodic::FGetPhase()
{
return fDIPERIODIC.dwPhase;
}
// --------------------------------------------------------------------------
void __fastcall TDIPeriodic::FSetPhase( dword pPhase )
{
fDIPERIODIC.dwPhase = pPhase;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property contains the size in bytes of the internal 
//              DIPERIODIC structure. 
// --------------------------------------------------------------------------
dword __fastcall TDIPeriodic::FGetSize()
{
return fSize;
}
// --------------------------------------------------------------------------
void __fastcall TDIPeriodic::FSetSize( dword pSize )
{
fSize = pSize;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TDIPeriodic's internal DIPERIODIC structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TDIPeriodic::Clear()
{
fErrorValue = DI_OK;
fDIPERIODIC.dwMagnitude = 0;
fDIPERIODIC.lOffset = 0;
fDIPERIODIC.dwPeriod = 0;
fDIPERIODIC.dwPhase = 0;
fSize = sizeof(DIPERIODIC);
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
DIPERIODIC* __fastcall TDIPeriodic::FGetInternal_DIPERIODIC_Ptr()
{
return &fDIPERIODIC;
}
// --------------------------------------------------------------------------
void __fastcall TDIPeriodic::FSetInternal_DIPERIODIC( DIPERIODIC* pDIPERIODIC )
{
if (pDIPERIODIC==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDIPeriodic::FSetInternal_DIPERIODIC()", "TDX_ERROR", "The supplied DIPERIODIC* was NULL" );
    return;
    }

CopyMemory( &fDIPERIODIC, pDIPERIODIC, sizeof(DIPERIODIC) );
Internal_DIPERIODIC_Update();
}
// --------------------------------------------------------------------------
void __fastcall TDIPeriodic::Internal_DIPERIODIC_Update()
{
}

// --------------------------------------------------------------------------
