// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDIPropHeader.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons, website),
//               Brian Austin (some source code, documentation)
// Description:  This file contains the code for the TDIPropHeader Component 
//
// "TDx_Input_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDIPropHeader.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Input_Library_Defns"
#pragma link "TDx_Input_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDIPropHeader*)
{
    new TDIPropHeader(NULL);
}
// --------------------------------------------------------------------------
namespace Tdipropheader
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDIPropHeader)};
        RegisterComponents("TDx_Input", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDIPropHeader::TDIPropHeader()
// Description: The default constructor for the TDIPropHeader object.
// --------------------------------------------------------------------------
__fastcall TDIPropHeader::TDIPropHeader(TComponent* Owner)
    : TComponent(Owner)
{
Clear();
}
// --------------------------------------------------------------------------
// Destructor:  TDIPropHeader::~TDIPropHeader()
// Description: The destructor for the TDIPropHeader object.
// --------------------------------------------------------------------------
__fastcall TDIPropHeader::~TDIPropHeader()
{
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDIPropHeader method or fget/fset. 
//              eg. DI_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDIPropHeader::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDIPropHeader::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    HeaderSize
// Description: The HeaderSize property defines the size, in bytes, of the 
//              internal DIPROPHEADER structure used by this component. 
// --------------------------------------------------------------------------
dword __fastcall TDIPropHeader::FGetHeaderSize()
{
return fDIPROPHEADER.dwHeaderSize;
}
// --------------------------------------------------------------------------
void __fastcall TDIPropHeader::FSetHeaderSize( dword pHeaderSize )
{
fDIPROPHEADER.dwHeaderSize = pHeaderSize;
}
// --------------------------------------------------------------------------
// Property:    How
// Description: The How property specifies how the TDIPropHeader::Obj 
//              property should be interpreted. 
//              The possible values are: 
//              
//              DIPH_DEVICE 
//                - TDIPropHeader::Obj must be zero. 
//              
//              DIPH_BYOFFSET 
//                - TDIPropHeader::Obj represents a byte offset into the data 
//              format of the object whose property setting is being 
//              accessed. 
//              
//              DIPH_BYID 
//                - TDIPropHeader::Obj represents an object type/instance 
//              identifier. The identifier can be found in 
//              TDIDeviceObjectInstance::Type when it returns from a 
//              TDx_InputDevice::EnumObjects() method call. 
// --------------------------------------------------------------------------
dword __fastcall TDIPropHeader::FGetHow()
{
return fDIPROPHEADER.dwHow;
}
// --------------------------------------------------------------------------
void __fastcall TDIPropHeader::FSetHow( dword pHow )
{
fDIPROPHEADER.dwHow = pHow;
}
// --------------------------------------------------------------------------
// Property:    Obj
// Description: The Obj property identifies the object whose property is to 
//              be accessed, either as an identifier or a data format offset. 
//              The interpretation of this property depends on the contents 
//              of TDIPropHeader::How. 
// --------------------------------------------------------------------------
dword __fastcall TDIPropHeader::FGetObj()
{
return fDIPROPHEADER.dwObj;
}
// --------------------------------------------------------------------------
void __fastcall TDIPropHeader::FSetObj( dword pObj )
{
fDIPROPHEADER.dwObj = pObj;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: Note: Unlike most Size properties, this property defines the 
//              size, in bytes, of the internal structure used within 
//              TDIPropDWORD, TDIPropGuidAndPath, TDIPropRange and 
//              TDIPropString components that have been linked to this 
//              TDIPropHeader component. This Size property does not define 
//              the size in bytes of the internal DIPROPHEADER structure used 
//              within this component. 
//              
//              For a more detailed description of this property, refer to 
//              the help on the TDIPropHeader component. 
// --------------------------------------------------------------------------
dword __fastcall TDIPropHeader::FGetSize()
{
return fSize;
}
// --------------------------------------------------------------------------
void __fastcall TDIPropHeader::FSetSize( dword pSize )
{
fSize = pSize;
fDIPROPHEADER.dwSize = fSize;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TDIPropHeader's internal DIPROPHEADER structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TDIPropHeader::Clear()
{
fErrorValue = DI_OK;
fDIPROPHEADER.dwHeaderSize = sizeof(DIPROPHEADER);
fDIPROPHEADER.dwHow = 0;
fDIPROPHEADER.dwObj = 0;
fSize = sizeof(DIPROPHEADER);
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
DIPROPHEADER* __fastcall TDIPropHeader::FGetInternal_DIPROPHEADER_Ptr()
{
return &fDIPROPHEADER;
}
// --------------------------------------------------------------------------
void __fastcall TDIPropHeader::FSetInternal_DIPROPHEADER( DIPROPHEADER* pDIPROPHEADER )
{
if (pDIPROPHEADER==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDIPropHeader::FSetInternal_DIPROPHEADER()", "TDX_ERROR", "The supplied DIPROPHEADER* was NULL" );
    return;
    }

CopyMemory( &fDIPROPHEADER, pDIPROPHEADER, sizeof(DIPROPHEADER) );
Internal_DIPROPHEADER_Update();
}
// --------------------------------------------------------------------------
void __fastcall TDIPropHeader::Internal_DIPROPHEADER_Update()
{
}

// --------------------------------------------------------------------------
