// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDIPropRange.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons, website),
//               Brian Austin (some source code, documentation)
// Description:  This file contains the code for the TDIPropRange Component 
//
// "TDx_Input_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDIPropRange.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Input_Library_Defns"
#pragma link "TDx_Input_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDIPropRange*)
{
    new TDIPropRange(NULL);
}
// --------------------------------------------------------------------------
namespace Tdiproprange
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDIPropRange)};
        RegisterComponents("TDx_Input", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDIPropRange::TDIPropRange()
// Description: The default constructor for the TDIPropRange object.
// --------------------------------------------------------------------------
__fastcall TDIPropRange::TDIPropRange(TComponent* Owner)
    : TDIProperty(Owner)
{
Clear();
}
// --------------------------------------------------------------------------
// Destructor:  TDIPropRange::~TDIPropRange()
// Description: The destructor for the TDIPropRange object.
// --------------------------------------------------------------------------
__fastcall TDIPropRange::~TDIPropRange()
{
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDIPropRange method or fget/fset. 
//              eg. DI_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDIPropRange::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDIPropRange::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    Max
// Description: The Max property defines the upper limit of the devices 
//              range. 
//              
//              This property will be DIPROPRANGE_NOMAX when 
//              TDx_InputDevice::GetProperty() returns if there are no range 
//              restrictions on the device. (A mouse axis for example) 
// --------------------------------------------------------------------------
long __fastcall TDIPropRange::FGetMax()
{
return fDIPROPRANGE.lMax;
}
// --------------------------------------------------------------------------
void __fastcall TDIPropRange::FSetMax( long pMax )
{
fDIPROPRANGE.lMax = pMax;
}
// --------------------------------------------------------------------------
// Property:    Min
// Description: The Min property defines the lower limit of the devices 
//              range. 
//              
//              This property will be DIPROPRANGE_NOMIN when 
//              TDx_InputDevice::GetProperty() returns if there are no range 
//              restrictions on the device. (A mouse axis for example) 
// --------------------------------------------------------------------------
long __fastcall TDIPropRange::FGetMin()
{
return fDIPROPRANGE.lMin;
}
// --------------------------------------------------------------------------
void __fastcall TDIPropRange::FSetMin( long pMin )
{
fDIPROPRANGE.lMin = pMin;
}
// --------------------------------------------------------------------------
// Property:    PropHeader
// Description: The PropHeader property can be used to link the TDIPropRange 
//              to a TDIPropHeader component using the Object Inspector or 
//              equivalent runtime code, and is used to access data inside 
//              the DIPROPHEADER structure that exists inside a DIPROPRANGE 
//              structure in a structure-in-structure relationship. 
//              
//              Normally in DirectX, you must setup the entire DIPROPRANGE 
//              structure including it's DIPROPHEADER structure according to 
//              specific rules. Upon linking a TDIPropHeader component to a 
//              TDIPropRange, much of the work has already been performed, 
//              but you still need to setup both the TDIPropHeader::Obj and 
//              the TDIPropHeader::How properties. 
//              
//              For Example :- 
//              
//              void __fastcall Form1::Button1Click(TObject* Sender) 
//              { 
//              DIPropHeader1->How = DIPH_DEVICE; 
//              DIPropHeader1->Obj = 0; 
//              
//              DIPropRange1->Min = -1000; 
//              DIPropRange1->Max = 1000; 
//              DIPropRange1->PropHeader = DIPropHeader1; 
//              
//              Dx_InputDevice1->SetProperty( DIPROP_RANGE, DIPropRange1 ); 
//              } 
// --------------------------------------------------------------------------
TDIPropHeader* __fastcall TDIPropRange::FGetPropHeader()
{
if (ComponentState.Contains(csDesigning) &&
    (fPropHeader!=NULL) &&
    (Owner!=NULL))
    {
    bool component_exists = false;
    for (int i=0;i<Owner->ComponentCount;i++)
        if (Owner->Components[i]==fPropHeader)
            {
            component_exists = true;
            break;
            }
    if (!component_exists) fPropHeader=NULL;
    }
return fPropHeader;
}
// --------------------------------------------------------------------------
void __fastcall TDIPropRange::FSetPropHeader( TDIPropHeader* pPropHeader )
{
fPropHeader = pPropHeader;
if (fPropHeader!=NULL) fPropHeader->Size = Size;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property contains the size in bytes of the internal 
//              DIPROPRANGE structure. 
// --------------------------------------------------------------------------
dword __fastcall TDIPropRange::FGetSize()
{
return fSize;
}
// --------------------------------------------------------------------------
void __fastcall TDIPropRange::FSetSize( dword pSize )
{
fSize = pSize;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TDIPropRange's internal DIPROPRANGE structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TDIPropRange::Clear()
{
fErrorValue = DI_OK;
fDIPROPRANGE.lMax = 0;
fDIPROPRANGE.lMin = 0;
fPropHeader = NULL;
fSize = sizeof(DIPROPRANGE);
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
DIPROPRANGE* __fastcall TDIPropRange::FGetInternal_DIPROPRANGE_Ptr()
{
if (fPropHeader!=NULL) CopyMemory( &fDIPROPRANGE.diph, fPropHeader->Internal_DIPROPHEADER_Ptr, sizeof(DIPROPHEADER) );
return &fDIPROPRANGE;
}
// --------------------------------------------------------------------------
void __fastcall TDIPropRange::FSetInternal_DIPROPRANGE( DIPROPRANGE* pDIPROPRANGE )
{
if (pDIPROPRANGE==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDIPropRange::FSetInternal_DIPROPRANGE()", "TDX_ERROR", "The supplied DIPROPRANGE* was NULL" );
    return;
    }

CopyMemory( &fDIPROPRANGE, pDIPROPRANGE, sizeof(DIPROPRANGE) );
Internal_DIPROPRANGE_Update();
}
// --------------------------------------------------------------------------
void __fastcall TDIPropRange::Internal_DIPROPRANGE_Update()
{
if (fPropHeader!=NULL) CopyMemory( fPropHeader->Internal_DIPROPHEADER_Ptr, &fDIPROPRANGE.diph, sizeof(DIPROPHEADER) );
}

// --------------------------------------------------------------------------
